/**==========================================================================

	PC-8001 Device Emulator for Win32 Ver 1.10
	Copyright (C)1993-2010 H.Kanemoto

	This is a free software. You may copy or distribute
	it without any permissions. But there are NO WARRANTY
	of use. Entire risk of use is with you.

	External assembler functions for IBM-PC with VC++ 5.0
	last modified  Apr,4,1998.

;==========================================================================*/
#ifndef _N80_H_
#define _N80_H_
#include "../z80/z80.h"
#ifdef __cplusplus
extern "C" {
#endif
#define export
typedef const DWORD	CDWORD, * LPCDWORD;
typedef const BYTE	CBYTE, * LPCBYTE;
/**--------------------------------------------------------------------------
 **		\
 **------------------------------------------------------------------------*/
typedef struct N80_tag {				// N80 Win32
	int			vtbl_vram20[20];		// DirectSurface VRAM offset table (20 Lines)
	int			vtbl_vram25[25];		// DirectSurface VRAM offset table (25 Lines) 
	LPBYTE		vram_addr;				// DirectSurface VRAM pointer
	DWORD		width;					// DirectSurface width
	DWORD		height;					// DirectSurface height
	DWORD		vram_lpitch;			// DirectSurface width pitch
	int			vram_pixcel_pitch;		// DirectSurface width pixcel pitch
	int			vram_vpitch[20];		// DirectSurface virtical pixcel pitch
	DWORD		vram_top_offset;		// DirectSurface top start line
	DWORD		vram_bottom_offset;		// DirectSurface bottom end line
	DWORD		vram_left_offset;		// DirectSurface left start width
	DWORD		vram_right_offset;		// DirectSurface right end width
	DWORD		screen_vpadding;		// screen top/bottom padding pixcels
	DWORD		screen_hpadding;		// screen left/right padding pixcels
	LPCBYTE		prime_palettes;			// primary palettes
	LPCBYTE		second_palettes;		// secondary paletts (interrace)
	LPCDWORD	prime_rgb_colors;		// primary rgb colors
	LPCDWORD	second_rgb_colors;		// seconday rgb colors (interrace)
	DWORD		cur_pix_rgb;			// current font rgb color
	DWORD		cur_pix_rgb2;			// current font rgb color (interrace)
	BYTE		cur_pix_rgb_pal;		// current font color palette no
	BYTE		cur_pix_rgb_pal2;		// current font color palette no (interrace)
	LONG		hard_volume;			// default DirectSound Hardware Volume
	LONG		soft_volume;			// default DirectSound Software Volume
	BOOL		tenkeyless;				// use ten keyless keyboard
	SHORT		screen_size;			// Window(Screen) size (0:autoA1:720x480)
	BOOL		m_z80_no_wait;			// z80 no-wait mode
	TCHAR		n80_rom_file_name[64];	// ROM file names
	TCHAR		_4th_rom_file_name[64];
	TCHAR		fdu_rom_file_name[64];

	double		eff_hz;					// Z80Clock(Hz)
	double		sys_hz;					// Z80_Clock(Hz)
	int			flips;					// bԕ`
	double		lines_per_flip;			// ϕ`֍s

	double		remain_ticks_top_sum;
	double		remain_ticks_sum;
	double		remain_minus_sum;
	LONGLONG	remain_top_minus_cnt;
	LONGLONG	remain_minus_cnt;
	LONGLONG	loop_cnt;

	LONG		(*get_hard_volume)(void);
	void		(*set_hard_volume)(LONG);
	SHORT		(*get_soft_volume)(void);
	void		(*set_soft_volume)(SHORT);
	void		(*set_tenkeyless)(BOOL);

}	N80, *LPN80;
/**--------------------------------------------------------------------------
 **		O[oϐ
 **------------------------------------------------------------------------*/
extern N80	n80win32;

#ifdef __cplusplus
}	// extern "C"
#endif
#endif//_N80_H_
