/**--------------------------------------------------------------------------
 **
 **		NEC PC-8001 Emulator "N80" for Win32/DirectX
 **		--------------------------------------------
 **		Copyright (c) 1993-2010 H.Kanemoto
 **
 **		DirectX
 **
 **		Rev		Date		Descriptions
 **		-----	----------	-----------------------------------------------
 **		1.00	1996/06/27	porting DOS version on WinG
 **		1.20	1997/08/10	porting WinG version on Win32/DirectX
 **		1.30	1998/03/12	
 **		1.43	2007/09/01	XPΉ
 **		1.44	2009/12/15	Vista/7Ή
 **		1.51	2010/01/27	DirectSound OnlyɕύX
 **------------------------------------------------------------------------*/
#ifndef  _N80_DIRECTX_H_
#define  _N80_DIRECTX_H_
#pragma once
#include "n80.h"
#include "../PC-8001/PC-8001.h"
#include "../lib/icj_thread.h"
#include <windows.h>
#include <ddraw.h>
#include <dsound.h>
/**==========================================================================
 **		萔}N`
 **========================================================================*/
#define	MAXTICKARRAY	(9600)
#define TICKBANKS		(2)
#define BEEPRATE		(2400)
#define SMPLRATE		(96000)				// TvO[g
#define SMPL2400		(SMPLRATE/BEEPRATE)	// 2400HzPgTv
#define CHANNELS		(1)					// m
#define BITPERSAMPLE	(16)				// ʎqrbg
#define BLOCKALIGN		(BITPERSAMPLE * CHANNELS / 8)
#define BYTEPERSEC		(BLOCKALIGN * SMPLRATE)
#define DELAYSAMPLES	(SMPLRATE/50)		// x20msecTv
#define DELAYBUFSIZE	(BYTEPERSEC/50)		// x20msecobt@TCY
/**==========================================================================
 **		ASM MODULE import ϐ^֐
 **========================================================================*/
extern "C" {
	extern N80DEVICE	n80device;
}
/**==========================================================================
 **		\̒`
 **========================================================================*/
typedef struct _SampleTicks {
	LONGLONG	mTicks;	// T-states݌v
	DWORD		mState;	// 0:off 1:on, PCG̏ꍇ̓Tv(g)
	ULONG		mFreq;	// original frequency
}	SampleTicks, *pSampleTicks;
typedef struct	_SapmleTsArr {
	SampleTicks	mArr[MAXTICKARRAY];		// Beep on/off Tickz
	int			mCount;					// Beep on/off Tickzvf
	int			mOverflow;				// Beep on/off Overflow TickzIndex
	LONGLONG	mTotal;					// Beep on/off Tick
}	SapmleTsArr, *pSapmleTsArr;
typedef struct	_SampleTsBank {
	SampleTicks	mCurrent;
	int			mBank;
	SapmleTsArr	mBanks[2];
}	SampleTsBank, *pSampleTsBank;
/**==========================================================================
 **		DirectX (Draw/Sound) NX
 **========================================================================*/
class n80_directx {
	//-----------------------------------------------------------------------
	//	oϐ
	//-----------------------------------------------------------------------
	protected:
	int					m_width;
	int					m_height;
	HWND				m_hwnd;
	int					m_show_sys_info;
	BOOL				m_use_palette;			// pbgFgp(8bpp)
	int					m_bpp_mode;				// 0:8bit-palette blt, 1:32bit RGB blt
	BOOL				m_fullscreen_mode;		// tXN[[h
	HFONT				m_font;					// font for sys-info text

	LPDIRECTDRAW		m_dd;					// DirectDraw Interface
	LPDIRECTDRAWSURFACE	m_dds1;					// Surface Interface #1
	LPDIRECTDRAWSURFACE	m_dds2;					// Surface Interface #2
	LPDIRECTDRAWPALETTE	m_ddp;					// Palette Interface
	DDCAPS				m_ddcap;
	DDSURFACEDESC		m_ddsd;
	LPPALETTEENTRY		m_palentry;
	
	LPDIRECTSOUND		m_ds;					// DirectSound Interface
	LPDIRECTSOUNDBUFFER m_dssb1;				// Buffer Interface #1 (Primary)
	LPDIRECTSOUNDBUFFER	m_dssb2;				// Buffer Interface #2
	DSBUFFERDESC		m_dsbdesk;
	BOOL				m_wait_vb;				// Vertical Blank wait flag

	BOOL				m_mute;					// TEh~[g
	short				m_beep_amplitude;		// Beepg`U
	short				m_pcg_amplitude;		// PCGg`U
	DSBPOSITIONNOTIFY	m_PosNotify[20];		// Sound Bufferʒmz

	short				m_delay_buff[DELAYSAMPLES];	// 48kHz(16bit)x0.2s

	LONGLONG			m_tick_delay;
	int					m_ticks_bank;			// Tick Bank
	SampleTsBank		m_beep_bank;			// TickJE^z(Beep)
	SampleTsBank		m_sound_bank[3];		// TickJE^z(PCG)
	SapmleTsArr			m_beep_copy_arr;		// TickJE^z(Beep)
	SapmleTsArr			m_sound_copy_bank[3];	// TickJE^z(PCG)
	RECT				m_dd_primary_rect;		// Primary Windows Client Rect
	int					m_next_sector;
	//-----------------------------------------------------------------------
	//	RXgN^^fXgN^
	//-----------------------------------------------------------------------
	public:
						n80_directx(void);
	virtual				~n80_directx(void);
	//-----------------------------------------------------------------------
	//	DirectX ֐
	//-----------------------------------------------------------------------
	public:
	virtual BOOL		init_dx(HWND hWnd);
	virtual BOOL		reinit_dd();
	virtual void		dispose_dx();
	virtual void		restore_surface();
	virtual int			realizer();
	virtual int			transfer();
	virtual LPBYTE		surface_lock();
	virtual int			flip(int);
	virtual void		draw_text(char text[25][80], char attr[25][80]);
	virtual BOOL		wait_vertical_blank_begin();
	virtual BOOL		wait_vertical_blank_end();
	virtual void		beep_on();
	virtual void		beep_off();
	virtual void		sound_on(ULONG freq, int ch);
	virtual void		sound_off();
	virtual void		clear_Ts_bank();
	virtual void		appendTs(LONGLONG tick);
	virtual void		play();
	virtual void		stop();
	virtual void		calc_delay_ticks();
	virtual void		reaclcWindowRect();
	virtual LPCBYTE		makepcm();
	virtual void		feedpcm(LPCBYTE);
	virtual int			next_sector(int sector) const { return (++sector & 3); }
	virtual int			prev_sector(int sector) const { return (--sector & 3); }
	//-----------------------------------------------------------------------
	//	vpeB֐
	//-----------------------------------------------------------------------
	virtual LONG		getHardVolume();
	virtual void		setHardVolume(LONG);
	virtual short		getSoftVolume();
	virtual void		setSoftVolume(short);
	virtual BOOL		getSyncVBlank() const { return m_wait_vb; }
	virtual void		setSyncVBlank(BOOL flag) { m_wait_vb = flag; }
	virtual BOOL		getMute() const { return m_mute; }
	virtual void		setMute(BOOL flag) { m_mute = flag; }
	virtual void		toggleMute() { m_mute = !m_mute; }
	virtual void		toggleShowSysInfo() { m_show_sys_info = m_show_sys_info == 0 ? 1 : -1; }
	virtual BOOL		getShowSysInfo() const { return m_show_sys_info != 0; }
	virtual BOOL		getFullScreenMode() const { return m_fullscreen_mode; }
	virtual void		setFullScreenMode(BOOL flag) { m_fullscreen_mode = flag; }
	virtual BOOL		getUsePalette() const { return m_use_palette; }
	virtual void		setUsePalette(BOOL flag) { m_use_palette = flag; }
	//	DirectDraw֐
	//-----------------------------------------------------------------------
	protected:
	DWORD				m_beep_phase_adjuster;			//WavʑJE^
	DWORD				m_sound_phase_adjuster;			//WavʑJE^

	BOOL				init_dd();
	void				dispose_dd();
	BOOL				create_dd(int x, int y, int depth);
	BOOL				create_surface();
	void				dispose_surface();
	BOOL				create_palette();
	void				dispose_palette();
	void				clear_surface();
	//-----------------------------------------------------------------------
	//	DirectSound֐
	//-----------------------------------------------------------------------
	BOOL				init_ds();
	void				dispose_ds();
	void				dispose_soundbuff();
	//-----------------------------------------------------------------------
	//	DirectSound PCM֐
	//-----------------------------------------------------------------------
	virtual void		appendPCMTick(pSampleTsBank bank, DWORD new_state, ULONG new_freq);
	virtual void		advanceTick(pSampleTsBank bank, LONGLONG diff);
	//-----------------------------------------------------------------------
	//	DirectSound Thread֐
	//-----------------------------------------------------------------------
	virtual void		exchangeBank(int *beep_bank, int *sound_bank);
	virtual LPCBYTE		makePCM(int beep_bank, int sound_bank);
	virtual void		makeNormalPCM(int beep_bank, int sound_bank);
	virtual void		transferPCM(LPCBYTE wav);
};
#endif //_N80_DIRECTX_H_
