/**--------------------------------------------------------------------------
 **
 **		NEC PC-8001 Emulator "N80" for Win32/DirectX
 **		--------------------------------------------
 **		Copyright (c) 1993-2010 H.Kanemoto
 **
 **		Main Window
 **
 **		Rev		Date		Descriptions
 **		-----	----------	-----------------------------------------------
 **		1.00	1996/06/27	porting DOS version on WinG
 **		1.20	1997/08/10	porting WinG version on Win32/DirectX
 **		1.30	1998/03/12	
 **		1.43	2007/09/01	XPΉ
 **		1.44	2009/12/15	Vista/7Ή
 **		1.51	2010/01/27	DirectSound OnlyɕύX
 **------------------------------------------------------------------------*/
#ifndef  _N80_FORM_H_
#define  _N80_FORM_H_
#define	 _CRT_SECURE_NO_WARNINGS 1
#define  IDM_N80CONFIG	1
#define  IDM_N80HELP	2
#define  IDM_N80RESET	3
#define	 KEYCOMB_CLEAR		0
#define	 KEYCOMB_ALT		1
#define	 KEYCOMB_ALT_DEL	2
#define	 KEYCOMB_ALT_INS	3
#define  CHOOSER_MODE_TAPE	0
#define  CHOOSER_MODE_D88	1
#define  WM_Z80_START		(WM_USER + 1)
#include <windows.h>
#include "n80.h"
#include "n80_assay.h"
#include "../PC-8001/PC-8001.h"
#include "../lib/icj_dib.h"
/**--------------------------------------------------------------------------
 **		Oϐ
 **------------------------------------------------------------------------*/
extern "C" {
extern N80DEVICE	n80device;
}
/**==========================================================================
 **		Main Form Class
 **========================================================================*/
class n80_form {
	//-----------------------------------------------------------------------
	//	NX֐
	//-----------------------------------------------------------------------
	public:
	static  BOOL				registerClass (HINSTANCE, HICON, HCURSOR, HBRUSH, LPCTSTR);
	static	int					messageLoop ();
	static	LRESULT CALLBACK	WndProc (HWND, UINT, WPARAM, LPARAM);
	//-----------------------------------------------------------------------
	//	oϐ
	//-----------------------------------------------------------------------
	private:
	HINSTANCE			mInstance;
	HWND				mWnd;
	icj_dib				mLogo;
	HPALETTE			mPal;
	HICON				mIcon;
	TCHAR				mTitleBase[512];
	TCHAR				mIniPath[512];
	BOOL				mReqRestart;	// Z80 thread ăX^[gv
	BOOL				mLostDDS;		// DirectDraw Surface/Z80 j
	HANDLE				m_hevt_sync;	// sync stop request event from primary thread
	HANDLE				m_hevt_ack;		// ack accept response event from z80 thread
	CRITICAL_SECTION	m_csec;
	int					m_key_combo;	// 0:none, 1:[ALT]+[DEL]+[1|2], 2:[ALT]+[INS]+[1|2]
	BOOL				m_config_mode;	// config screen | emulator screen
	//-----------------------------------------------------------------------
	//	RXgN^^fXgN^
	//-----------------------------------------------------------------------
	public:
						n80_form(HINSTANCE);
	virtual				~n80_form();
	//-----------------------------------------------------------------------
	//	Jϐ
	//-----------------------------------------------------------------------
	char				m_cui_text[25][80];
	char				m_cui_attr[25][80];
	//-----------------------------------------------------------------------
	//	J\bh
	//-----------------------------------------------------------------------
	HINSTANCE			getInstance() const { return mInstance; }
	HWND				getHWnd() const { return mWnd; }
	HICON				getIcon() { return mIcon; }
	virtual BOOL		create(LPCSTR clsname, LPCTSTR title, 
								int x=CW_USEDEFAULT,  int y=CW_USEDEFAULT,
								int w=CW_USEDEFAULT, int h=CW_USEDEFAULT);
	virtual int			postMessage(UINT msg, WPARAM wp, LPARAM lp);
	virtual BOOL		init();
	void				prepareWindowMode(int width, int height);
	void				prepareFullScreenMode(int width, int height);
	//-----------------------------------------------------------------------
	//	J\bh
	//-----------------------------------------------------------------------
	protected:
	virtual LRESULT		defWndproc(HWND, UINT, WPARAM, LPARAM);
	virtual LRESULT		cfgWndproc(HWND, UINT, WPARAM, LPARAM);
	//-----------------------------------------------------------------------
	//	N80\bh
	//-----------------------------------------------------------------------
	void				clearRAM();
	BOOL				loadROM();
	BOOL				loadDiskROM();
	BOOL				loadBMP();
	BOOL				loadFont();
	BOOL				loadIcon();
	void				loadProfile(LPCTSTR);
	void				saveProfile(LPCTSTR);
	BOOL				initProfile();
	void				initKeyb();
	//-----------------------------------------------------------------------
	//	t@CI
	//-----------------------------------------------------------------------
	void				chooser(BYTE mode, int unit);
	void				drop_file(LPCTSTR path, int unit);
	BOOL				open_file(BYTE mode, LPSTR);
	void				read_file(LPCSTR);
	void				cach_file(LPCSTR);
	BOOL				read_d88_file(LPCTSTR path, int unit);
	void				conv_file(LPCSTR);
	void				membin_file(LPCSTR);
	//-----------------------------------------------------------------------
	//	CMTo̓t@CI
	//-----------------------------------------------------------------------
	void				cmtsave();
	BOOL				save_cmt_file(LPSTR);
	//-----------------------------------------------------------------------
	//	DUMPo
	//-----------------------------------------------------------------------
	void				dump();
	BOOL				save_file(LPSTR);
	void				write_file(LPCSTR);
	//-----------------------------------------------------------------------
	//	@\ݒ
	//-----------------------------------------------------------------------
	void				preference();
	void				enter_config_mode();
	void				leave_config_mode();
	void				drawitem(LPVOID item, int line, bool selected);
	//-----------------------------------------------------------------------
	//	wv
	//-----------------------------------------------------------------------
	void				about();
	void				title_update();
	//-----------------------------------------------------------------------
	//	}Vԑ
	//-----------------------------------------------------------------------
	void				start();
	void				restart();
	void				reset();
	void				exit();
	void				halt(LPZ80CPU cpu);
	void				change_screen();
	void				fd_eject(int unit);
	//-----------------------------------------------------------------------
	//	WindowCxgnh
	//-----------------------------------------------------------------------
	virtual void		OnAppActivate(BOOL);
	virtual void		OnPaint();
	virtual void		OnDraw(HDC);
	virtual BOOL		OnEraseBkgnd(HDC);
	virtual void		OnKeyDown(int vk);
	virtual void		OnKeyUp(int vk);
	virtual void		ForceShowCursor();
	virtual void		ForceHideCursor();
	virtual void		ShowCursorFullScreen();
	virtual void		HideCursorFullScreen();
};
/**==========================================================================
 **		ASM MODULE import ϐ^֐
 **========================================================================*/
extern "C" {
	//extern void		_blt_mmx();			// blt.asm
}
#endif //_N80_FORM_H_
