/**--------------------------------------------------------------------------
 **
 **		NEC PC-8001 Emulator "N80" for Win32/DirectX
 **		--------------------------------------------
 **		Copyright (c) 1993-2010 H.Kanemoto
 **
 **		Keyboard
 **
 **		Rev		Date		Descriptions
 **		-----	----------	-----------------------------------------------
 **		1.00	1996/06/27	porting DOS version on WinG
 **		1.20	1997/08/10	porting WinG version on Win32/DirectX
 **		1.30	1998/03/12	
 **		1.43	2007/09/01	XPΉ
 **		1.44	2009/12/15	Vista/7Ή
 **		1.51	2010/01/27	DirectSound OnlyɕύX
 **------------------------------------------------------------------------*/
#include "n80_form.h"
/**--------------------------------------------------------------------------
 **		ASM MODULE export ϐ
 **------------------------------------------------------------------------*/
static BYTE  key_convert[256] = 	// VF to N80 converter
{
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,	/* 00	*/
    0x48, 0xff, 0xff, 0xff, 0xff, 0x0f, 0xff, 0xff,
    0x46, 0x47, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,	/* 10	*/
    0xff, 0xff, 0xff, 0x4f, 0x45, 0x44, 0xff, 0xff,
    0x4e, 0xff, 0xff, 0xff, 0x40, 0x42, 0x41, 0x42,	/* 20	*/
    0x41, 0xff, 0xff, 0xff, 0xff, 0x43, 0x43, 0xff,
    0x30, 0x31, 0x32, 0x33, 0x34, 0x35, 0x36, 0x37,	/* 30	*/
    0x38, 0x39, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0x11, 0x12, 0x13, 0x14, 0x15, 0x16, 0x17,	/* 40	*/
    0x18, 0x19, 0x1a, 0x1b, 0x1c, 0x1d, 0x1e, 0x1f,
    0x20, 0x21, 0x22, 0x23, 0x24, 0x25, 0x26, 0x27,	/* 50	*/
    0x28, 0x29, 0x2a, 0xff, 0xff, 0xff, 0xff, 0xff,
    0x00, 0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07,	/* 60	*/
    0x08, 0x09, 0x0a, 0x0b, 0xff, 0xff, 0x0e, 0xff,
    0x49, 0x4a, 0x4b, 0x4c, 0x4d, 0xff, 0xff, 0xff,	/* 70	*/
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,	/* 80	*/
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,	/* 90	*/
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0x47, 0x47, 0xff, 0xff, 0xff, 0xff,	/* A0	*/
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,	/* B0	*/
    0xff, 0xff, 0x3a, 0x3b, 0x3c, 0x2f, 0x3d, 0x3e,
    0x10, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,	/* C0	*/
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,	/* D0	*/
    0xff, 0xff, 0xff, 0x2b, 0x2c, 0x2d, 0x2e, 0xff,
    0xff, 0xff, 0x3f, 0xff, 0xff, 0xff, 0xff, 0xff,	/* E0	*/
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0x45, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,	/* F0	*/
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff
};
static BYTE  down_matorix[80][2] =
{
	{0,0xfe}, {0,0xfd}, {0,0xfb}, {0,0xf7},
	{0,0xef}, {0,0xdf}, {0,0xbf}, {0,0x7f},
	{1,0xfe}, {1,0xfd}, {1,0xfb}, {1,0xf7},
	{1,0xef}, {1,0xdf}, {1,0xbf}, {1,0x7f},
	{2,0xfe}, {2,0xfd}, {2,0xfb}, {2,0xf7},
	{2,0xef}, {2,0xdf}, {2,0xbf}, {2,0x7f},
	{3,0xfe}, {3,0xfd}, {3,0xfb}, {3,0xf7},
	{3,0xef}, {3,0xdf}, {3,0xbf}, {3,0x7f},
	{4,0xfe}, {4,0xfd}, {4,0xfb}, {4,0xf7},
	{4,0xef}, {4,0xdf}, {4,0xbf}, {4,0x7f},
	{5,0xfe}, {5,0xfd}, {5,0xfb}, {5,0xf7},
	{5,0xef}, {5,0xdf}, {5,0xbf}, {5,0x7f},
	{6,0xfe}, {6,0xfd}, {6,0xfb}, {6,0xf7},
	{6,0xef}, {6,0xdf}, {6,0xbf}, {6,0x7f},
	{7,0xfe}, {7,0xfd}, {7,0xfb}, {7,0xf7},
	{7,0xef}, {7,0xdf}, {7,0xbf}, {7,0x7f},
	{8,0xfe}, {8,0xfd}, {8,0xfb}, {8,0xf7},
	{8,0xef}, {8,0xdf}, {8,0xbf}, {8,0x7f},
	{9,0xfe}, {9,0xfd}, {9,0xfb}, {9,0xf7},
	{9,0xef}, {9,0xdf}, {9,0xbf}, {9,0x7f}
};
static BYTE  up_matorix[80][2] =
{
	{0,0x01}, {0,0x02}, {0,0x04}, {0,0x08},
	{0,0x10}, {0,0x20}, {0,0x40}, {0,0x80},
	{1,0x01}, {1,0x02}, {1,0x04}, {1,0x08},
	{1,0x10}, {1,0x20}, {1,0x40}, {1,0x80},
	{2,0x01}, {2,0x02}, {2,0x04}, {2,0x08},
	{2,0x10}, {2,0x20}, {2,0x40}, {2,0x80},
	{3,0x01}, {3,0x02}, {3,0x04}, {3,0x08},
	{3,0x10}, {3,0x20}, {3,0x40}, {3,0x80},
	{4,0x01}, {4,0x02}, {4,0x04}, {4,0x08},
	{4,0x10}, {4,0x20}, {4,0x40}, {4,0x80},
	{5,0x01}, {5,0x02}, {5,0x04}, {5,0x08},
	{5,0x10}, {5,0x20}, {5,0x40}, {5,0x80},
	{6,0x01}, {6,0x02}, {6,0x04}, {6,0x08},
	{6,0x10}, {6,0x20}, {6,0x40}, {6,0x80},
	{7,0x01}, {7,0x02}, {7,0x04}, {7,0x08},
	{7,0x10}, {7,0x20}, {7,0x40}, {7,0x80},
	{8,0x01}, {8,0x02}, {8,0x04}, {8,0x08},
	{8,0x10}, {8,0x20}, {8,0x40}, {8,0x80},
	{9,0x01}, {9,0x02}, {9,0x04}, {9,0x08},
	{9,0x10}, {9,0x20}, {9,0x40}, {9,0x80}
};
/**--------------------------------------------------------------------------
 **		KEY 
 **------------------------------------------------------------------------*/
static void set_tenkeyless(BOOL flag) {
	n80win32.tenkeyless = flag;
	n80device.io.clear_keys();
	//TEN KeyȂꍇ̓J[\KeyTEN Key 2468蓖Ă
	if (n80win32.tenkeyless) {
		key_convert[0x25] = 0x04;
		key_convert[0x26] = 0x08;
		key_convert[0x27] = 0x06;
		key_convert[0x28] = 0x02;
	} else {
		key_convert[0x25] = 0x42;
		key_convert[0x26] = 0x41;
		key_convert[0x27] = 0x42;
		key_convert[0x28] = 0x41;
	}
}
void
n80_form::initKeyb ()
{
	n80win32.set_tenkeyless = set_tenkeyless;
	set_tenkeyless(n80win32.tenkeyless);
}
/**--------------------------------------------------------------------------
 **		KEY Cxg
 **------------------------------------------------------------------------*/
void
n80_form::OnKeyDown (int vkcode)
{
	BYTE	bit;
	int		index, nidx;

	index = key_convert[vkcode];
	if (index == 0xff)
		return;
	nidx =  down_matorix[index][0];
	bit  =  down_matorix[index][1];

	n80device.io.keys[nidx] &= bit;
}

void
n80_form::OnKeyUp (int vkcode)
{
	BYTE	bit;
	int		index, nidx;

	index = key_convert[vkcode];
	if (index == 0xff)
		return;
	nidx =  up_matorix[index][0];
	bit  =  up_matorix[index][1];

	n80device.io.keys[nidx] |= bit;
}
