/**==========================================================================

	PC-8001 Device Emulator for Win32 Ver 1.10
	Copyright (C)1993-2010 H.Kanemoto

	This is a free software. You may copy or distribute
	it without any permissions. But there are NO WARRANTY
	of use. Entire risk of use is with you.

	External assembler functions for IBM-PC with VC++ 5.0
	last modified  Apr,4,1998.

;==========================================================================*/
#include "PC-8001.h"
#ifdef __cplusplus
extern "C"
{
#endif
/**--------------------------------------------------------------------------
 **		ASM Modules
 **------------------------------------------------------------------------*/
export BYTE __cdecl _n80_mbread(LPZ80CPU cpu, USHORT Adr, DWORD *W) {
	//if (Adr < 0x6000)	// ROM
	//	++(*W);
	return n80device.mem._arr[Adr];
}

export void __cdecl _n80_mbwrite(LPZ80CPU cpu, USHORT Adr, BYTE v, DWORD *W) {
	if (Adr >= 0x8000) {
		if (Adr >= n80device.dmac._begin && Adr < n80device.dmac._end) {
			// Sync Video RAM Area
			n80device.vram_sync_enter();
			n80device.mem._arr[Adr] = v;
			n80device.attr._attrchg[((Adr - n80device.dmac._begin) / 120)] = 1;
			n80device.vram_sync_leave();
		} else {
			n80device.mem._arr[Adr] = v;
		}
	} else if (Adr >= 0x6000 && !n80device.param.attach_4th_rom) {
		n80device.mem._arr[Adr] = v;	//PasocomMini݊
	}
}

static void clear_ram_core(LPBYTE mem) {
	int  i;

	for (i = 0; i < 0x1000; ++i) {
		*mem++ = 0x00;
		*mem++ = 0xff;
	}
	for (i = 0; i < 0x1000; ++i) {
		*mem++ = 0xff;
		*mem++ = 0x00;
	}
	for (i = 0; i < 128; ++i) {
		int  j;

		for (j = 0; j < 64; ++j)
			*mem++ = 0xff;
		for (j = 0; j < 64; ++j)
			*mem++ = 0x00;
	}
}

static void _n80_clear_memory(void) {
	LPBYTE	mem = n80device.mem._ram;
	clear_ram_core(mem);
}

export void _n80_init_memory(void) {
	n80device.mem.read	= _n80_mbread;
	n80device.mem.write = _n80_mbwrite;
	n80device.mem.clear = _n80_clear_memory;
	n80device.mem._rom	= &n80device.mem._arr[0];
	n80device.mem._4th	= &n80device.mem._arr[0x6000];
	n80device.mem._ram	= &n80device.mem._arr[0x8000];
	_n80_clear_memory();
}

#ifdef __cplusplus
}	// extern "C"
#endif
