/**--------------------------------------------------------------------------
 **
 **		Z80 Emulator Ver 3.00
 **		Copyright (C)1993-2010 H.Kanemoto
 **
 **		This is a free software. You may copy or distribute
 **		it without any permissions. But there are NO WARRANTY
 **		of use. Entire risk of use is with you.
 **
 **------------------------------------------------------------------------*/
#include "z80.h"
#include "z80mac.h"
#ifdef __cplusplus
extern "C"
{
#endif
#define export
/**--------------------------------------------------------------------------
 **		Decoder
 **------------------------------------------------------------------------*/
export void _dz80_decoder_cb(Z80CPU *cpu) {
	switch (cpu->dbgctx.fetchb(cpu)) {
	case 0x00: __dz80_op_plane(cpu, "RLC B");		break;
	case 0x01: __dz80_op_plane(cpu, "RLC C");		break;
	case 0x02: __dz80_op_plane(cpu, "RLC D");		break;
	case 0x03: __dz80_op_plane(cpu, "RLC E");		break;
	case 0x04: __dz80_op_plane(cpu, "RLC H");		break;
	case 0x05: __dz80_op_plane(cpu, "RLC L");		break;
	case 0x06: __dz80_op_plane(cpu, "RLC (HL)");	break;
	case 0x07: __dz80_op_plane(cpu, "RLC A");		break;

	case 0x08: __dz80_op_plane(cpu, "RRC B");		break;
	case 0x09: __dz80_op_plane(cpu, "RRC C");		break;
	case 0x0A: __dz80_op_plane(cpu, "RRC D");		break;
	case 0x0B: __dz80_op_plane(cpu, "RRC E");		break;
	case 0x0C: __dz80_op_plane(cpu, "RRC H");		break;
	case 0x0D: __dz80_op_plane(cpu, "RRC L");		break;
	case 0x0E: __dz80_op_plane(cpu, "RRC (HL)");	break;
	case 0x0F: __dz80_op_plane(cpu, "RRC A");		break;

	case 0x10: __dz80_op_plane(cpu, "RL B");		break;
	case 0x11: __dz80_op_plane(cpu, "RL C");		break;
	case 0x12: __dz80_op_plane(cpu, "RL D");		break;
	case 0x13: __dz80_op_plane(cpu, "RL E");		break;
	case 0x14: __dz80_op_plane(cpu, "RL H");		break;
	case 0x15: __dz80_op_plane(cpu, "RL L");		break;
	case 0x16: __dz80_op_plane(cpu, "RL (HL)");		break;
	case 0x17: __dz80_op_plane(cpu, "RL A");		break;

	case 0x18: __dz80_op_plane(cpu, "RR B");		break;
	case 0x19: __dz80_op_plane(cpu, "RR C");		break;
	case 0x1A: __dz80_op_plane(cpu, "RR D");		break;
	case 0x1B: __dz80_op_plane(cpu, "RR E");		break;
	case 0x1C: __dz80_op_plane(cpu, "RR H");		break;
	case 0x1D: __dz80_op_plane(cpu, "RR L");		break;
	case 0x1E: __dz80_op_plane(cpu, "RR (HL)");		break;
	case 0x1F: __dz80_op_plane(cpu, "RR A");		break;

	case 0x20: __dz80_op_plane(cpu, "SLA B");		break;
	case 0x21: __dz80_op_plane(cpu, "SLA C");		break;
	case 0x22: __dz80_op_plane(cpu, "SLA D");		break;
	case 0x23: __dz80_op_plane(cpu, "SLA E");		break;
	case 0x24: __dz80_op_plane(cpu, "SLA H");		break;
	case 0x25: __dz80_op_plane(cpu, "SLA L");		break;
	case 0x26: __dz80_op_plane(cpu, "SLA (HL)");	break;
	case 0x27: __dz80_op_plane(cpu, "SLA A");		break;

	case 0x28: __dz80_op_plane(cpu, "SRA B");		break;
	case 0x29: __dz80_op_plane(cpu, "SRA C");		break;
	case 0x2A: __dz80_op_plane(cpu, "SRA D");		break;
	case 0x2B: __dz80_op_plane(cpu, "SRA E");		break;
	case 0x2C: __dz80_op_plane(cpu, "SRA H");		break;
	case 0x2D: __dz80_op_plane(cpu, "SRA L");		break;
	case 0x2E: __dz80_op_plane(cpu, "SRA (HL)");	break;
	case 0x2F: __dz80_op_plane(cpu, "SRA A");		break;

	case 0x30: __dz80_op_plane(cpu, "SLL B");		break;
	case 0x31: __dz80_op_plane(cpu, "SLL C");		break;
	case 0x32: __dz80_op_plane(cpu, "SLL D");		break;
	case 0x33: __dz80_op_plane(cpu, "SLL E");		break;
	case 0x34: __dz80_op_plane(cpu, "SLL H");		break;
	case 0x35: __dz80_op_plane(cpu, "SLL L");		break;
	case 0x36: __dz80_op_plane(cpu, "SLL (HL)");	break;
	case 0x37: __dz80_op_plane(cpu, "SLL A");		break;

	case 0x38: __dz80_op_plane(cpu, "SRL B");		break;
	case 0x39: __dz80_op_plane(cpu, "SRL C");		break;
	case 0x3A: __dz80_op_plane(cpu, "SRL D");		break;
	case 0x3B: __dz80_op_plane(cpu, "SRL E");		break;
	case 0x3C: __dz80_op_plane(cpu, "SRL H");		break;
	case 0x3D: __dz80_op_plane(cpu, "SRL L");		break;
	case 0x3E: __dz80_op_plane(cpu, "SRL (HL)");	break;
	case 0x3F: __dz80_op_plane(cpu, "SRL A");		break;

	case 0x40: __dz80_op_plane(cpu, "BIT 0,B");		break;
	case 0x41: __dz80_op_plane(cpu, "BIT 0,C");		break;
	case 0x42: __dz80_op_plane(cpu, "BIT 0,D");		break;
	case 0x43: __dz80_op_plane(cpu, "BIT 0,E");		break;
	case 0x44: __dz80_op_plane(cpu, "BIT 0,H");		break;
	case 0x45: __dz80_op_plane(cpu, "BIT 0,L");		break;
	case 0x46: __dz80_op_plane(cpu, "BIT 0,(HL)");	break;
	case 0x47: __dz80_op_plane(cpu, "BIT 0,A");		break;

	case 0x48: __dz80_op_plane(cpu, "BIT 1,B");		break;
	case 0x49: __dz80_op_plane(cpu, "BIT 1,C");		break;
	case 0x4A: __dz80_op_plane(cpu, "BIT 1,D");		break;
	case 0x4B: __dz80_op_plane(cpu, "BIT 1,E");		break;
	case 0x4C: __dz80_op_plane(cpu, "BIT 1,H");		break;
	case 0x4D: __dz80_op_plane(cpu, "BIT 1,L");		break;
	case 0x4E: __dz80_op_plane(cpu, "BIT 1,(HL)");	break;
	case 0x4F: __dz80_op_plane(cpu, "BIT 1,A");		break;

	case 0x50: __dz80_op_plane(cpu, "BIT 2,B");		break;
	case 0x51: __dz80_op_plane(cpu, "BIT 2,C");		break;
	case 0x52: __dz80_op_plane(cpu, "BIT 2,D");		break;
	case 0x53: __dz80_op_plane(cpu, "BIT 2,E");		break;
	case 0x54: __dz80_op_plane(cpu, "BIT 2,H");		break;
	case 0x55: __dz80_op_plane(cpu, "BIT 2,L");		break;
	case 0x56: __dz80_op_plane(cpu, "BIT 2,(HL)");	break;
	case 0x57: __dz80_op_plane(cpu, "BIT 2,A");		break;

	case 0x58: __dz80_op_plane(cpu, "BIT 3,B");		break;
	case 0x59: __dz80_op_plane(cpu, "BIT 3,C");		break;
	case 0x5A: __dz80_op_plane(cpu, "BIT 3,D");		break;
	case 0x5B: __dz80_op_plane(cpu, "BIT 3,E");		break;
	case 0x5C: __dz80_op_plane(cpu, "BIT 3,H");		break;
	case 0x5D: __dz80_op_plane(cpu, "BIT 3,L");		break;
	case 0x5E: __dz80_op_plane(cpu, "BIT 3,(HL)");	break;
	case 0x5F: __dz80_op_plane(cpu, "BIT 3,A");		break;

	case 0x60: __dz80_op_plane(cpu, "BIT 4,B");		break;
	case 0x61: __dz80_op_plane(cpu, "BIT 4,C");		break;
	case 0x62: __dz80_op_plane(cpu, "BIT 4,D");		break;
	case 0x63: __dz80_op_plane(cpu, "BIT 4,E");		break;
	case 0x64: __dz80_op_plane(cpu, "BIT 4,H");		break;
	case 0x65: __dz80_op_plane(cpu, "BIT 4,L");		break;
	case 0x66: __dz80_op_plane(cpu, "BIT 4,(HL)");	break;
	case 0x67: __dz80_op_plane(cpu, "BIT 4,A");		break;

	case 0x68: __dz80_op_plane(cpu, "BIT 5,B");		break;
	case 0x69: __dz80_op_plane(cpu, "BIT 5,C");		break;
	case 0x6A: __dz80_op_plane(cpu, "BIT 5,D");		break;
	case 0x6B: __dz80_op_plane(cpu, "BIT 5,E");		break;
	case 0x6C: __dz80_op_plane(cpu, "BIT 5,H");		break;
	case 0x6D: __dz80_op_plane(cpu, "BIT 5,L");		break;
	case 0x6E: __dz80_op_plane(cpu, "BIT 5,(HL)");	break;
	case 0x6F: __dz80_op_plane(cpu, "BIT 5,A");		break;

	case 0x70: __dz80_op_plane(cpu, "BIT 6,B");		break;
	case 0x71: __dz80_op_plane(cpu, "BIT 6,C");		break;
	case 0x72: __dz80_op_plane(cpu, "BIT 6,D");		break;
	case 0x73: __dz80_op_plane(cpu, "BIT 6,E");		break;
	case 0x74: __dz80_op_plane(cpu, "BIT 6,H");		break;
	case 0x75: __dz80_op_plane(cpu, "BIT 6,L");		break;
	case 0x76: __dz80_op_plane(cpu, "BIT 6,(HL)");	break;
	case 0x77: __dz80_op_plane(cpu, "BIT 6,A");		break;

	case 0x78: __dz80_op_plane(cpu, "BIT 7,B");		break;
	case 0x79: __dz80_op_plane(cpu, "BIT 7,C");		break;
	case 0x7A: __dz80_op_plane(cpu, "BIT 7,D");		break;
	case 0x7B: __dz80_op_plane(cpu, "BIT 7,E");		break;
	case 0x7C: __dz80_op_plane(cpu, "BIT 7,H");		break;
	case 0x7D: __dz80_op_plane(cpu, "BIT 7,L");		break;
	case 0x7E: __dz80_op_plane(cpu, "BIT 7,(HL)");	break;
	case 0x7F: __dz80_op_plane(cpu, "BIT 7,A");		break;

	case 0x80: __dz80_op_plane(cpu, "RES 0,B");		break;
	case 0x81: __dz80_op_plane(cpu, "RES 0,C");		break;
	case 0x82: __dz80_op_plane(cpu, "RES 0,D");		break;
	case 0x83: __dz80_op_plane(cpu, "RES 0,E");		break;
	case 0x84: __dz80_op_plane(cpu, "RES 0,H");		break;
	case 0x85: __dz80_op_plane(cpu, "RES 0,L");		break;
	case 0x86: __dz80_op_plane(cpu, "RES 0,(HL)");	break;
	case 0x87: __dz80_op_plane(cpu, "RES 0,A");		break;

	case 0x88: __dz80_op_plane(cpu, "RES 1,B");		break;
	case 0x89: __dz80_op_plane(cpu, "RES 1,C");		break;
	case 0x8A: __dz80_op_plane(cpu, "RES 1,D");		break;
	case 0x8B: __dz80_op_plane(cpu, "RES 1,E");		break;
	case 0x8C: __dz80_op_plane(cpu, "RES 1,H");		break;
	case 0x8D: __dz80_op_plane(cpu, "RES 1,L");		break;
	case 0x8E: __dz80_op_plane(cpu, "RES 1,(HL)");	break;
	case 0x8F: __dz80_op_plane(cpu, "RES 1,A");		break;

	case 0x90: __dz80_op_plane(cpu, "RES 2,B");		break;
	case 0x91: __dz80_op_plane(cpu, "RES 2,C");		break;
	case 0x92: __dz80_op_plane(cpu, "RES 2,D");		break;
	case 0x93: __dz80_op_plane(cpu, "RES 2,E");		break;
	case 0x94: __dz80_op_plane(cpu, "RES 2,H");		break;
	case 0x95: __dz80_op_plane(cpu, "RES 2,L");		break;
	case 0x96: __dz80_op_plane(cpu, "RES 2,(HL)");	break;
	case 0x97: __dz80_op_plane(cpu, "RES 2,A");		break;

	case 0x98: __dz80_op_plane(cpu, "RES 3,B");		break;
	case 0x99: __dz80_op_plane(cpu, "RES 3,C");		break;
	case 0x9A: __dz80_op_plane(cpu, "RES 3,D");		break;
	case 0x9B: __dz80_op_plane(cpu, "RES 3,E");		break;
	case 0x9C: __dz80_op_plane(cpu, "RES 3,H");		break;
	case 0x9D: __dz80_op_plane(cpu, "RES 3,L");		break;
	case 0x9E: __dz80_op_plane(cpu, "RES 3,(HL)");	break;
	case 0x9F: __dz80_op_plane(cpu, "RES 3,A");		break;

	case 0xA0: __dz80_op_plane(cpu, "RES 4,B");		break;
	case 0xA1: __dz80_op_plane(cpu, "RES 4,C");		break;
	case 0xA2: __dz80_op_plane(cpu, "RES 4,D");		break;
	case 0xA3: __dz80_op_plane(cpu, "RES 4,E");		break;
	case 0xA4: __dz80_op_plane(cpu, "RES 4,H");		break;
	case 0xA5: __dz80_op_plane(cpu, "RES 4,L");		break;
	case 0xA6: __dz80_op_plane(cpu, "RES 4,(HL)");	break;
	case 0xA7: __dz80_op_plane(cpu, "RES 4,A");		break;

	case 0xA8: __dz80_op_plane(cpu, "RES 5,B");		break;
	case 0xA9: __dz80_op_plane(cpu, "RES 5,C");		break;
	case 0xAA: __dz80_op_plane(cpu, "RES 5,D");		break;
	case 0xAB: __dz80_op_plane(cpu, "RES 5,E");		break;
	case 0xAC: __dz80_op_plane(cpu, "RES 5,H");		break;
	case 0xAD: __dz80_op_plane(cpu, "RES 5,L");		break;
	case 0xAE: __dz80_op_plane(cpu, "RES 5,(HL)");	break;
	case 0xAF: __dz80_op_plane(cpu, "RES 5,A");		break;

	case 0xB0: __dz80_op_plane(cpu, "RES 6,B");		break;
	case 0xB1: __dz80_op_plane(cpu, "RES 6,C");		break;
	case 0xB2: __dz80_op_plane(cpu, "RES 6,D");		break;
	case 0xB3: __dz80_op_plane(cpu, "RES 6,E");		break;
	case 0xB4: __dz80_op_plane(cpu, "RES 6,H");		break;
	case 0xB5: __dz80_op_plane(cpu, "RES 6,L");		break;
	case 0xB6: __dz80_op_plane(cpu, "RES 6,(HL)");	break;
	case 0xB7: __dz80_op_plane(cpu, "RES 6,A");		break;

	case 0xB8: __dz80_op_plane(cpu, "RES 7,B");		break;
	case 0xB9: __dz80_op_plane(cpu, "RES 7,C");		break;
	case 0xBA: __dz80_op_plane(cpu, "RES 7,D");		break;
	case 0xBB: __dz80_op_plane(cpu, "RES 7,E");		break;
	case 0xBC: __dz80_op_plane(cpu, "RES 7,H");		break;
	case 0xBD: __dz80_op_plane(cpu, "RES 7,L");		break;
	case 0xBE: __dz80_op_plane(cpu, "RES 7,(HL)");	break;
	case 0xBF: __dz80_op_plane(cpu, "RES 7,A");		break;

	case 0xC0: __dz80_op_plane(cpu, "SET 0,B");		break;
	case 0xC1: __dz80_op_plane(cpu, "SET 0,C");		break;
	case 0xC2: __dz80_op_plane(cpu, "SET 0,D");		break;
	case 0xC3: __dz80_op_plane(cpu, "SET 0,E");		break;
	case 0xC4: __dz80_op_plane(cpu, "SET 0,H");		break;
	case 0xC5: __dz80_op_plane(cpu, "SET 0,L");		break;
	case 0xC6: __dz80_op_plane(cpu, "SET 0,(HL)");	break;
	case 0xC7: __dz80_op_plane(cpu, "SET 0,A");		break;

	case 0xC8: __dz80_op_plane(cpu, "SET 1,B");		break;
	case 0xC9: __dz80_op_plane(cpu, "SET 1,C");		break;
	case 0xCA: __dz80_op_plane(cpu, "SET 1,D");		break;
	case 0xCB: __dz80_op_plane(cpu, "SET 1,E");		break;
	case 0xCC: __dz80_op_plane(cpu, "SET 1,H");		break;
	case 0xCD: __dz80_op_plane(cpu, "SET 1,L");		break;
	case 0xCE: __dz80_op_plane(cpu, "SET 1,(HL)");	break;
	case 0xCF: __dz80_op_plane(cpu, "SET 1,A");		break;

	case 0xD0: __dz80_op_plane(cpu, "SET 2,B");		break;
	case 0xD1: __dz80_op_plane(cpu, "SET 2,C");		break;
	case 0xD2: __dz80_op_plane(cpu, "SET 2,D");		break;
	case 0xD3: __dz80_op_plane(cpu, "SET 2,E");		break;
	case 0xD4: __dz80_op_plane(cpu, "SET 2,H");		break;
	case 0xD5: __dz80_op_plane(cpu, "SET 2,L");		break;
	case 0xD6: __dz80_op_plane(cpu, "SET 2,(HL)");	break;
	case 0xD7: __dz80_op_plane(cpu, "SET 2,A");		break;

	case 0xD8: __dz80_op_plane(cpu, "SET 3,B");		break;
	case 0xD9: __dz80_op_plane(cpu, "SET 3,C");		break;
	case 0xDA: __dz80_op_plane(cpu, "SET 3,D");		break;
	case 0xDB: __dz80_op_plane(cpu, "SET 3,E");		break;
	case 0xDC: __dz80_op_plane(cpu, "SET 3,H");		break;
	case 0xDD: __dz80_op_plane(cpu, "SET 3,L");		break;
	case 0xDE: __dz80_op_plane(cpu, "SET 3,(HL)");	break;
	case 0xDF: __dz80_op_plane(cpu, "SET 3,A");		break;

	case 0xE0: __dz80_op_plane(cpu, "SET 4,B");		break;
	case 0xE1: __dz80_op_plane(cpu, "SET 4,C");		break;
	case 0xE2: __dz80_op_plane(cpu, "SET 4,D");		break;
	case 0xE3: __dz80_op_plane(cpu, "SET 4,E");		break;
	case 0xE4: __dz80_op_plane(cpu, "SET 4,H");		break;
	case 0xE5: __dz80_op_plane(cpu, "SET 4,L");		break;
	case 0xE6: __dz80_op_plane(cpu, "SET 4,(HL)");	break;
	case 0xE7: __dz80_op_plane(cpu, "SET 4,A");		break;

	case 0xE8: __dz80_op_plane(cpu, "SET 5,B");		break;
	case 0xE9: __dz80_op_plane(cpu, "SET 5,C");		break;
	case 0xEA: __dz80_op_plane(cpu, "SET 5,D");		break;
	case 0xEB: __dz80_op_plane(cpu, "SET 5,E");		break;
	case 0xEC: __dz80_op_plane(cpu, "SET 5,H");		break;
	case 0xED: __dz80_op_plane(cpu, "SET 5,L");		break;
	case 0xEE: __dz80_op_plane(cpu, "SET 5,(HL)");	break;
	case 0xEF: __dz80_op_plane(cpu, "SET 5,A");		break;

	case 0xF0: __dz80_op_plane(cpu, "SET 6,B");		break;
	case 0xF1: __dz80_op_plane(cpu, "SET 6,C");		break;
	case 0xF2: __dz80_op_plane(cpu, "SET 6,D");		break;
	case 0xF3: __dz80_op_plane(cpu, "SET 6,E");		break;
	case 0xF4: __dz80_op_plane(cpu, "SET 6,H");		break;
	case 0xF5: __dz80_op_plane(cpu, "SET 6,L");		break;
	case 0xF6: __dz80_op_plane(cpu, "SET 6,(HL)");	break;
	case 0xF7: __dz80_op_plane(cpu, "SET 6,A");		break;

	case 0xF8: __dz80_op_plane(cpu, "SET 7,B");		break;
	case 0xF9: __dz80_op_plane(cpu, "SET 7,C");		break;
	case 0xFA: __dz80_op_plane(cpu, "SET 7,D");		break;
	case 0xFB: __dz80_op_plane(cpu, "SET 7,E");		break;
	case 0xFC: __dz80_op_plane(cpu, "SET 7,H");		break;
	case 0xFD: __dz80_op_plane(cpu, "SET 7,L");		break;
	case 0xFE: __dz80_op_plane(cpu, "SET 7,(HL)");	break;
	case 0xFF: __dz80_op_plane(cpu, "SET 7,A");		break;
	}
}

#ifdef __cplusplus
}	// extern "C"
#endif
