/**--------------------------------------------------------------------------
 **
 **		Z80 Emulator Ver 3.00
 **		Copyright (C)1993-2010 H.Kanemoto
 **
 **		This is a free software. You may copy or distribute
 **		it without any permissions. But there are NO WARRANTY
 **		of use. Entire risk of use is with you.
 **
 **------------------------------------------------------------------------*/
#include "z80.h"
#include "z80mac.h"
#ifdef __cplusplus
extern "C"
{
#endif
#define export
/**--------------------------------------------------------------------------
 **		Decoder
 **------------------------------------------------------------------------*/
export void _dz80_decoder_dd_cb(Z80CPU *cpu) {
	BYTE d = cpu->dbgctx.fetchb(cpu);
	switch (cpu->dbgctx.fetchb(cpu)) {
	case 0x00: __dz80_op_ixd0(cpu, d, "RLC (IX+d),B");		break;
	case 0x01: __dz80_op_ixd0(cpu, d, "RLC (IX+d),C");		break;
	case 0x02: __dz80_op_ixd0(cpu, d, "RLC (IX+d),D");		break;
	case 0x03: __dz80_op_ixd0(cpu, d, "RLC (IX+d),E");		break;
	case 0x04: __dz80_op_ixd0(cpu, d, "RLC (IX+d),H");		break;
	case 0x05: __dz80_op_ixd0(cpu, d, "RLC (IX+d),L");		break;
	case 0x06: __dz80_op_ixd0(cpu, d, "RLC (IX+d)  ");		break;
	case 0x07: __dz80_op_ixd0(cpu, d, "RLC (IX+d),A");		break;

	case 0x08: __dz80_op_ixd0(cpu, d, "RRC (IX+d),B");		break;
	case 0x09: __dz80_op_ixd0(cpu, d, "RRC (IX+d),C");		break;
	case 0x0A: __dz80_op_ixd0(cpu, d, "RRC (IX+d),D");		break;
	case 0x0B: __dz80_op_ixd0(cpu, d, "RRC (IX+d),E");		break;
	case 0x0C: __dz80_op_ixd0(cpu, d, "RRC (IX+d),H");		break;
	case 0x0D: __dz80_op_ixd0(cpu, d, "RRC (IX+d),L");		break;
	case 0x0E: __dz80_op_ixd0(cpu, d, "RRC (IX+d)  ");		break;
	case 0x0F: __dz80_op_ixd0(cpu, d, "RRC (IX+d),A");		break;

	case 0x10: __dz80_op_ixd0(cpu, d, "RL (IX+d),B");		break;
	case 0x11: __dz80_op_ixd0(cpu, d, "RL (IX+d),C");		break;
	case 0x12: __dz80_op_ixd0(cpu, d, "RL (IX+d),D");		break;
	case 0x13: __dz80_op_ixd0(cpu, d, "RL (IX+d),E");		break;
	case 0x14: __dz80_op_ixd0(cpu, d, "RL (IX+d),H");		break;
	case 0x15: __dz80_op_ixd0(cpu, d, "RL (IX+d),L");		break;
	case 0x16: __dz80_op_ixd0(cpu, d, "RL (IX+d)  ");		break;
	case 0x17: __dz80_op_ixd0(cpu, d, "RL (IX+d),A");		break;

	case 0x18: __dz80_op_ixd0(cpu, d, "RR (IX+d),B");		break;
	case 0x19: __dz80_op_ixd0(cpu, d, "RR (IX+d),C");		break;
	case 0x1A: __dz80_op_ixd0(cpu, d, "RR (IX+d),D");		break;
	case 0x1B: __dz80_op_ixd0(cpu, d, "RR (IX+d),E");		break;
	case 0x1C: __dz80_op_ixd0(cpu, d, "RR (IX+d),H");		break;
	case 0x1D: __dz80_op_ixd0(cpu, d, "RR (IX+d),L");		break;
	case 0x1E: __dz80_op_ixd0(cpu, d, "RR (IX+d)  ");		break;
	case 0x1F: __dz80_op_ixd0(cpu, d, "RR (IX+d),A");		break;

	case 0x20: __dz80_op_ixd0(cpu, d, "SLA (IX+d),B");		break;
	case 0x21: __dz80_op_ixd0(cpu, d, "SLA (IX+d),C");		break;
	case 0x22: __dz80_op_ixd0(cpu, d, "SLA (IX+d),D");		break;
	case 0x23: __dz80_op_ixd0(cpu, d, "SLA (IX+d),E");		break;
	case 0x24: __dz80_op_ixd0(cpu, d, "SLA (IX+d),H");		break;
	case 0x25: __dz80_op_ixd0(cpu, d, "SLA (IX+d),L");		break;
	case 0x26: __dz80_op_ixd0(cpu, d, "SLA (IX+d)  ");		break;
	case 0x27: __dz80_op_ixd0(cpu, d, "SLA (IX+d),A");		break;

	case 0x28: __dz80_op_ixd0(cpu, d, "SRA (IX+d),B");		break;
	case 0x29: __dz80_op_ixd0(cpu, d, "SRA (IX+d),C");		break;
	case 0x2A: __dz80_op_ixd0(cpu, d, "SRA (IX+d),D");		break;
	case 0x2B: __dz80_op_ixd0(cpu, d, "SRA (IX+d),E");		break;
	case 0x2C: __dz80_op_ixd0(cpu, d, "SRA (IX+d),H");		break;
	case 0x2D: __dz80_op_ixd0(cpu, d, "SRA (IX+d),L");		break;
	case 0x2E: __dz80_op_ixd0(cpu, d, "SRA (IX+d)  ");		break;
	case 0x2F: __dz80_op_ixd0(cpu, d, "SRA (IX+d),A");		break;

	case 0x30: __dz80_op_ixd0(cpu, d, "SLL (IX+d),B");		break;
	case 0x31: __dz80_op_ixd0(cpu, d, "SLL (IX+d),C");		break;
	case 0x32: __dz80_op_ixd0(cpu, d, "SLL (IX+d),D");		break;
	case 0x33: __dz80_op_ixd0(cpu, d, "SLL (IX+d),E");		break;
	case 0x34: __dz80_op_ixd0(cpu, d, "SLL (IX+d),H");		break;
	case 0x35: __dz80_op_ixd0(cpu, d, "SLL (IX+d),L");		break;
	case 0x36: __dz80_op_ixd0(cpu, d, "SLL (IX+d)  ");		break;
	case 0x37: __dz80_op_ixd0(cpu, d, "SLL (IX+d),A");		break;

	case 0x38: __dz80_op_ixd0(cpu, d, "SRL (IX+d),B");		break;
	case 0x39: __dz80_op_ixd0(cpu, d, "SRL (IX+d),C");		break;
	case 0x3A: __dz80_op_ixd0(cpu, d, "SRL (IX+d),D");		break;
	case 0x3B: __dz80_op_ixd0(cpu, d, "SRL (IX+d),E");		break;
	case 0x3C: __dz80_op_ixd0(cpu, d, "SRL (IX+d),H");		break;
	case 0x3D: __dz80_op_ixd0(cpu, d, "SRL (IX+d),L");		break;
	case 0x3E: __dz80_op_ixd0(cpu, d, "SRL (IX+d)  ");		break;
	case 0x3F: __dz80_op_ixd0(cpu, d, "SRL (IX+d),A");		break;

	case 0x40: __dz80_op_ixd0(cpu, d, "BIT 0,(IX+d),B");	break;
	case 0x41: __dz80_op_ixd0(cpu, d, "BIT 0,(IX+d),C");	break;
	case 0x42: __dz80_op_ixd0(cpu, d, "BIT 0,(IX+d),D");	break;
	case 0x43: __dz80_op_ixd0(cpu, d, "BIT 0,(IX+d),E");	break;
	case 0x44: __dz80_op_ixd0(cpu, d, "BIT 0,(IX+d),H");	break;
	case 0x45: __dz80_op_ixd0(cpu, d, "BIT 0,(IX+d),L");	break;
	case 0x46: __dz80_op_ixd0(cpu, d, "BIT 0,(IX+d)");		break;
	case 0x47: __dz80_op_ixd0(cpu, d, "BIT 0,(IX+d),A");	break;

	case 0x48: __dz80_op_ixd0(cpu, d, "BIT 1,(IX+d),B");	break;
	case 0x49: __dz80_op_ixd0(cpu, d, "BIT 1,(IX+d),C");	break;
	case 0x4A: __dz80_op_ixd0(cpu, d, "BIT 1,(IX+d),D");	break;
	case 0x4B: __dz80_op_ixd0(cpu, d, "BIT 1,(IX+d),E");	break;
	case 0x4C: __dz80_op_ixd0(cpu, d, "BIT 1,(IX+d),H");	break;
	case 0x4D: __dz80_op_ixd0(cpu, d, "BIT 1,(IX+d),L");	break;
	case 0x4E: __dz80_op_ixd0(cpu, d, "BIT 1,(IX+d)");		break;
	case 0x4F: __dz80_op_ixd0(cpu, d, "BIT 1,(IX+d),A");	break;

	case 0x50: __dz80_op_ixd0(cpu, d, "BIT 2,(IX+d),B");	break;
	case 0x51: __dz80_op_ixd0(cpu, d, "BIT 2,(IX+d),C");	break;
	case 0x52: __dz80_op_ixd0(cpu, d, "BIT 2,(IX+d),D");	break;
	case 0x53: __dz80_op_ixd0(cpu, d, "BIT 2,(IX+d),E");	break;
	case 0x54: __dz80_op_ixd0(cpu, d, "BIT 2,(IX+d),H");	break;
	case 0x55: __dz80_op_ixd0(cpu, d, "BIT 2,(IX+d),L");	break;
	case 0x56: __dz80_op_ixd0(cpu, d, "BIT 2,(IX+d)");		break;
	case 0x57: __dz80_op_ixd0(cpu, d, "BIT 2,(IX+d),A");	break;

	case 0x58: __dz80_op_ixd0(cpu, d, "BIT 3,(IX+d),B");	break;
	case 0x59: __dz80_op_ixd0(cpu, d, "BIT 3,(IX+d),C");	break;
	case 0x5A: __dz80_op_ixd0(cpu, d, "BIT 3,(IX+d),D");	break;
	case 0x5B: __dz80_op_ixd0(cpu, d, "BIT 3,(IX+d),E");	break;
	case 0x5C: __dz80_op_ixd0(cpu, d, "BIT 3,(IX+d),H");	break;
	case 0x5D: __dz80_op_ixd0(cpu, d, "BIT 3,(IX+d),L");	break;
	case 0x5E: __dz80_op_ixd0(cpu, d, "BIT 3,(IX+d)");		break;
	case 0x5F: __dz80_op_ixd0(cpu, d, "BIT 3,(IX+d),A");	break;

	case 0x60: __dz80_op_ixd0(cpu, d, "BIT 4,(IX+d),B");	break;
	case 0x61: __dz80_op_ixd0(cpu, d, "BIT 4,(IX+d),C");	break;
	case 0x62: __dz80_op_ixd0(cpu, d, "BIT 4,(IX+d),D");	break;
	case 0x63: __dz80_op_ixd0(cpu, d, "BIT 4,(IX+d),E");	break;
	case 0x64: __dz80_op_ixd0(cpu, d, "BIT 4,(IX+d),H");	break;
	case 0x65: __dz80_op_ixd0(cpu, d, "BIT 4,(IX+d),L");	break;
	case 0x66: __dz80_op_ixd0(cpu, d, "BIT 4,(IX+d)");		break;
	case 0x67: __dz80_op_ixd0(cpu, d, "BIT 4,(IX+d),A");	break;

	case 0x68: __dz80_op_ixd0(cpu, d, "BIT 5,(IX+d),B");	break;
	case 0x69: __dz80_op_ixd0(cpu, d, "BIT 5,(IX+d),C");	break;
	case 0x6A: __dz80_op_ixd0(cpu, d, "BIT 5,(IX+d),D");	break;
	case 0x6B: __dz80_op_ixd0(cpu, d, "BIT 5,(IX+d),E");	break;
	case 0x6C: __dz80_op_ixd0(cpu, d, "BIT 5,(IX+d),H");	break;
	case 0x6D: __dz80_op_ixd0(cpu, d, "BIT 5,(IX+d),L");	break;
	case 0x6E: __dz80_op_ixd0(cpu, d, "BIT 5,(IX+d)");		break;
	case 0x6F: __dz80_op_ixd0(cpu, d, "BIT 5,(IX+d),A");	break;

	case 0x70: __dz80_op_ixd0(cpu, d, "BIT 6,(IX+d),B");	break;
	case 0x71: __dz80_op_ixd0(cpu, d, "BIT 6,(IX+d),C");	break;
	case 0x72: __dz80_op_ixd0(cpu, d, "BIT 6,(IX+d),D");	break;
	case 0x73: __dz80_op_ixd0(cpu, d, "BIT 6,(IX+d),E");	break;
	case 0x74: __dz80_op_ixd0(cpu, d, "BIT 6,(IX+d),H");	break;
	case 0x75: __dz80_op_ixd0(cpu, d, "BIT 6,(IX+d),L");	break;
	case 0x76: __dz80_op_ixd0(cpu, d, "BIT 6,(IX+d)");		break;
	case 0x77: __dz80_op_ixd0(cpu, d, "BIT 6,(IX+d),A");	break;

	case 0x78: __dz80_op_ixd0(cpu, d, "BIT 7,(IX+d),B");	break;
	case 0x79: __dz80_op_ixd0(cpu, d, "BIT 7,(IX+d),C");	break;
	case 0x7A: __dz80_op_ixd0(cpu, d, "BIT 7,(IX+d),D");	break;
	case 0x7B: __dz80_op_ixd0(cpu, d, "BIT 7,(IX+d),E");	break;
	case 0x7C: __dz80_op_ixd0(cpu, d, "BIT 7,(IX+d),H");	break;
	case 0x7D: __dz80_op_ixd0(cpu, d, "BIT 7,(IX+d),L");	break;
	case 0x7E: __dz80_op_ixd0(cpu, d, "BIT 7,(IX+d)");		break;
	case 0x7F: __dz80_op_ixd0(cpu, d, "BIT 7,(IX+d),A");	break;

	case 0x80: __dz80_op_ixd0(cpu, d, "RES 0,(IX+d),B");	break;
	case 0x81: __dz80_op_ixd0(cpu, d, "RES 0,(IX+d),C");	break;
	case 0x82: __dz80_op_ixd0(cpu, d, "RES 0,(IX+d),D");	break;
	case 0x83: __dz80_op_ixd0(cpu, d, "RES 0,(IX+d),E");	break;
	case 0x84: __dz80_op_ixd0(cpu, d, "RES 0,(IX+d),H");	break;
	case 0x86: __dz80_op_ixd0(cpu, d, "RES 0,(IX+d)");		break;
	case 0x87: __dz80_op_ixd0(cpu, d, "RES 0,(IX+d),A");	break;

	case 0x88: __dz80_op_ixd0(cpu, d, "RES 1,(IX+d),B");	break;
	case 0x89: __dz80_op_ixd0(cpu, d, "RES 1,(IX+d),C");	break;
	case 0x8A: __dz80_op_ixd0(cpu, d, "RES 1,(IX+d),D");	break;
	case 0x8B: __dz80_op_ixd0(cpu, d, "RES 1,(IX+d),E");	break;
	case 0x8C: __dz80_op_ixd0(cpu, d, "RES 1,(IX+d),H");	break;
	case 0x8D: __dz80_op_ixd0(cpu, d, "RES 1,(IX+d),L");	break;
	case 0x8E: __dz80_op_ixd0(cpu, d, "RES 1,(IX+d)");		break;
	case 0x8F: __dz80_op_ixd0(cpu, d, "RES 1,(IX+d),A");	break;

	case 0x90: __dz80_op_ixd0(cpu, d, "RES 2,(IX+d),B");	break;
	case 0x91: __dz80_op_ixd0(cpu, d, "RES 2,(IX+d),C");	break;
	case 0x92: __dz80_op_ixd0(cpu, d, "RES 2,(IX+d),D");	break;
	case 0x93: __dz80_op_ixd0(cpu, d, "RES 2,(IX+d),E");	break;
	case 0x94: __dz80_op_ixd0(cpu, d, "RES 2,(IX+d),H");	break;
	case 0x95: __dz80_op_ixd0(cpu, d, "RES 2,(IX+d),L");	break;
	case 0x96: __dz80_op_ixd0(cpu, d, "RES 2,(IX+d)");		break;
	case 0x97: __dz80_op_ixd0(cpu, d, "RES 2,(IX+d),A");	break;

	case 0x98: __dz80_op_ixd0(cpu, d, "RES 3,(IX+d),B");	break;
	case 0x99: __dz80_op_ixd0(cpu, d, "RES 3,(IX+d),C");	break;
	case 0x9A: __dz80_op_ixd0(cpu, d, "RES 3,(IX+d),D");	break;
	case 0x9B: __dz80_op_ixd0(cpu, d, "RES 3,(IX+d),E");	break;
	case 0x9C: __dz80_op_ixd0(cpu, d, "RES 3,(IX+d),H");	break;
	case 0x9D: __dz80_op_ixd0(cpu, d, "RES 3,(IX+d),L");	break;
	case 0x9E: __dz80_op_ixd0(cpu, d, "RES 3,(IX+d)");		break;
	case 0x9F: __dz80_op_ixd0(cpu, d, "RES 3,(IX+d),A");	break;

	case 0xA0: __dz80_op_ixd0(cpu, d, "RES 4,(IX+d),B");	break;
	case 0xA1: __dz80_op_ixd0(cpu, d, "RES 4,(IX+d),C");	break;
	case 0xA2: __dz80_op_ixd0(cpu, d, "RES 4,(IX+d),D");	break;
	case 0xA3: __dz80_op_ixd0(cpu, d, "RES 4,(IX+d),E");	break;
	case 0xA4: __dz80_op_ixd0(cpu, d, "RES 4,(IX+d),H");	break;
	case 0xA5: __dz80_op_ixd0(cpu, d, "RES 4,(IX+d),L");	break;
	case 0xA6: __dz80_op_ixd0(cpu, d, "RES 4,(IX+d)");		break;
	case 0xA7: __dz80_op_ixd0(cpu, d, "RES 4,(IX+d),A");	break;

	case 0xA8: __dz80_op_ixd0(cpu, d, "RES 5,(IX+d),B");	break;
	case 0xA9: __dz80_op_ixd0(cpu, d, "RES 5,(IX+d),C");	break;
	case 0xAA: __dz80_op_ixd0(cpu, d, "RES 5,(IX+d),D");	break;
	case 0xAB: __dz80_op_ixd0(cpu, d, "RES 5,(IX+d),E");	break;
	case 0xAC: __dz80_op_ixd0(cpu, d, "RES 5,(IX+d),H");	break;
	case 0xAD: __dz80_op_ixd0(cpu, d, "RES 5,(IX+d),L");	break;
	case 0xAE: __dz80_op_ixd0(cpu, d, "RES 5,(IX+d)");		break;
	case 0xAF: __dz80_op_ixd0(cpu, d, "RES 5,(IX+d),A");	break;

	case 0xB0: __dz80_op_ixd0(cpu, d, "RES 6,(IX+d),B");	break;
	case 0xB1: __dz80_op_ixd0(cpu, d, "RES 6,(IX+d),C");	break;
	case 0xB2: __dz80_op_ixd0(cpu, d, "RES 6,(IX+d),D");	break;
	case 0xB3: __dz80_op_ixd0(cpu, d, "RES 6,(IX+d),E");	break;
	case 0xB4: __dz80_op_ixd0(cpu, d, "RES 6,(IX+d),H");	break;
	case 0xB5: __dz80_op_ixd0(cpu, d, "RES 6,(IX+d),L");	break;
	case 0xB6: __dz80_op_ixd0(cpu, d, "RES 6,(IX+d)");		break;
	case 0xB7: __dz80_op_ixd0(cpu, d, "RES 6,(IX+d),A");	break;

	case 0xB8: __dz80_op_ixd0(cpu, d, "RES 7,(IX+d),B");	break;
	case 0xB9: __dz80_op_ixd0(cpu, d, "RES 7,(IX+d),C");	break;
	case 0xBA: __dz80_op_ixd0(cpu, d, "RES 7,(IX+d),D");	break;
	case 0xBB: __dz80_op_ixd0(cpu, d, "RES 7,(IX+d),E");	break;
	case 0xBC: __dz80_op_ixd0(cpu, d, "RES 7,(IX+d),H");	break;
	case 0xBD: __dz80_op_ixd0(cpu, d, "RES 7,(IX+d),L");	break;
	case 0xBE: __dz80_op_ixd0(cpu, d, "RES 7,(IX+d)");		break;
	case 0xBF: __dz80_op_ixd0(cpu, d, "RES 7,(IX+d),A");	break;

	case 0xC0: __dz80_op_ixd0(cpu, d, "SET 0,(IX+d),B");	break;
	case 0xC1: __dz80_op_ixd0(cpu, d, "SET 0,(IX+d),C");	break;
	case 0xC2: __dz80_op_ixd0(cpu, d, "SET 0,(IX+d),D");	break;
	case 0xC3: __dz80_op_ixd0(cpu, d, "SET 0,(IX+d),E");	break;
	case 0xC4: __dz80_op_ixd0(cpu, d, "SET 0,(IX+d),H");	break;
	case 0xC6: __dz80_op_ixd0(cpu, d, "SET 0,(IX+d)");		break;
	case 0xC7: __dz80_op_ixd0(cpu, d, "SET 0,(IX+d),A");	break;

	case 0xC8: __dz80_op_ixd0(cpu, d, "SET 1,(IX+d),B");	break;
	case 0xC9: __dz80_op_ixd0(cpu, d, "SET 1,(IX+d),C");	break;
	case 0xCA: __dz80_op_ixd0(cpu, d, "SET 1,(IX+d),D");	break;
	case 0xCB: __dz80_op_ixd0(cpu, d, "SET 1,(IX+d),E");	break;
	case 0xCC: __dz80_op_ixd0(cpu, d, "SET 1,(IX+d),H");	break;
	case 0xCD: __dz80_op_ixd0(cpu, d, "SET 1,(IX+d),L");	break;
	case 0xCE: __dz80_op_ixd0(cpu, d, "SET 1,(IX+d)");		break;
	case 0xCF: __dz80_op_ixd0(cpu, d, "SET 1,(IX+d),A");	break;

	case 0xD0: __dz80_op_ixd0(cpu, d, "SET 2,(IX+d),B");	break;
	case 0xD1: __dz80_op_ixd0(cpu, d, "SET 2,(IX+d),C");	break;
	case 0xD2: __dz80_op_ixd0(cpu, d, "SET 2,(IX+d),D");	break;
	case 0xD3: __dz80_op_ixd0(cpu, d, "SET 2,(IX+d),E");	break;
	case 0xD4: __dz80_op_ixd0(cpu, d, "SET 2,(IX+d),H");	break;
	case 0xD6: __dz80_op_ixd0(cpu, d, "SET 2,(IX+d)");		break;
	case 0xD7: __dz80_op_ixd0(cpu, d, "SET 2,(IX+d),A");	break;

	case 0xD8: __dz80_op_ixd0(cpu, d, "SET 3,(IX+d),B");	break;
	case 0xD9: __dz80_op_ixd0(cpu, d, "SET 3,(IX+d),C");	break;
	case 0xDA: __dz80_op_ixd0(cpu, d, "SET 3,(IX+d),D");	break;
	case 0xDB: __dz80_op_ixd0(cpu, d, "SET 3,(IX+d),E");	break;
	case 0xDC: __dz80_op_ixd0(cpu, d, "SET 3,(IX+d),H");	break;
	case 0xDD: __dz80_op_ixd0(cpu, d, "SET 3,(IX+d),L");	break;
	case 0xDE: __dz80_op_ixd0(cpu, d, "SET 3,(IX+d)");		break;
	case 0xDF: __dz80_op_ixd0(cpu, d, "SET 3,(IX+d),A");	break;

	case 0xE0: __dz80_op_ixd0(cpu, d, "SET 4,(IX+d),B");	break;
	case 0xE1: __dz80_op_ixd0(cpu, d, "SET 4,(IX+d),C");	break;
	case 0xE2: __dz80_op_ixd0(cpu, d, "SET 4,(IX+d),D");	break;
	case 0xE3: __dz80_op_ixd0(cpu, d, "SET 4,(IX+d),E");	break;
	case 0xE4: __dz80_op_ixd0(cpu, d, "SET 4,(IX+d),H");	break;
	case 0xE6: __dz80_op_ixd0(cpu, d, "SET 4,(IX+d)");		break;
	case 0xE7: __dz80_op_ixd0(cpu, d, "SET 4,(IX+d),A");	break;

	case 0xE8: __dz80_op_ixd0(cpu, d, "SET 5,(IX+d),B");	break;
	case 0xE9: __dz80_op_ixd0(cpu, d, "SET 5,(IX+d),C");	break;
	case 0xEA: __dz80_op_ixd0(cpu, d, "SET 5,(IX+d),D");	break;
	case 0xEB: __dz80_op_ixd0(cpu, d, "SET 5,(IX+d),E");	break;
	case 0xEC: __dz80_op_ixd0(cpu, d, "SET 5,(IX+d),H");	break;
	case 0xED: __dz80_op_ixd0(cpu, d, "SET 5,(IX+d),L");	break;
	case 0xEE: __dz80_op_ixd0(cpu, d, "SET 5,(IX+d)");		break;
	case 0xEF: __dz80_op_ixd0(cpu, d, "SET 5,(IX+d),A");	break;

	case 0xF0: __dz80_op_ixd0(cpu, d, "SET 6,(IX+d),B");	break;
	case 0xF1: __dz80_op_ixd0(cpu, d, "SET 6,(IX+d),C");	break;
	case 0xF2: __dz80_op_ixd0(cpu, d, "SET 6,(IX+d),D");	break;
	case 0xF3: __dz80_op_ixd0(cpu, d, "SET 6,(IX+d),E");	break;
	case 0xF4: __dz80_op_ixd0(cpu, d, "SET 6,(IX+d),H");	break;
	case 0xF6: __dz80_op_ixd0(cpu, d, "SET 6,(IX+d)");		break;
	case 0xF7: __dz80_op_ixd0(cpu, d, "SET 6,(IX+d),A");	break;

	case 0xF8: __dz80_op_ixd0(cpu, d, "SET 7,(IX+d),B");	break;
	case 0xF9: __dz80_op_ixd0(cpu, d, "SET 7,(IX+d),C");	break;
	case 0xFA: __dz80_op_ixd0(cpu, d, "SET 7,(IX+d),D");	break;
	case 0xFB: __dz80_op_ixd0(cpu, d, "SET 7,(IX+d),E");	break;
	case 0xFC: __dz80_op_ixd0(cpu, d, "SET 7,(IX+d),H");	break;
	case 0xFD: __dz80_op_ixd0(cpu, d, "SET 7,(IX+d),L");	break;
	case 0xFE: __dz80_op_ixd0(cpu, d, "SET 7,(IX+d)");		break;
	case 0xFF: __dz80_op_ixd0(cpu, d, "SET 7,(IX+d),A");	break;
	}
}

export void _dz80_decoder_fd_cb(Z80CPU *cpu) {
	BYTE d = cpu->dbgctx.fetchb(cpu);
	switch (cpu->dbgctx.fetchb(cpu)) {
	case 0x00: __dz80_op_ixd0(cpu, d, "RLC (IY+d),B");		break;
	case 0x01: __dz80_op_ixd0(cpu, d, "RLC (IY+d),C");		break;
	case 0x02: __dz80_op_ixd0(cpu, d, "RLC (IY+d),D");		break;
	case 0x03: __dz80_op_ixd0(cpu, d, "RLC (IY+d),E");		break;
	case 0x04: __dz80_op_ixd0(cpu, d, "RLC (IY+d),H");		break;
	case 0x05: __dz80_op_ixd0(cpu, d, "RLC (IY+d),L");		break;
	case 0x06: __dz80_op_ixd0(cpu, d, "RLC (IY+d)  ");		break;
	case 0x07: __dz80_op_ixd0(cpu, d, "RLC (IY+d),A");		break;

	case 0x08: __dz80_op_ixd0(cpu, d, "RRC (IY+d),B");		break;
	case 0x09: __dz80_op_ixd0(cpu, d, "RRC (IY+d),C");		break;
	case 0x0A: __dz80_op_ixd0(cpu, d, "RRC (IY+d),D");		break;
	case 0x0B: __dz80_op_ixd0(cpu, d, "RRC (IY+d),E");		break;
	case 0x0C: __dz80_op_ixd0(cpu, d, "RRC (IY+d),H");		break;
	case 0x0D: __dz80_op_ixd0(cpu, d, "RRC (IY+d),L");		break;
	case 0x0E: __dz80_op_ixd0(cpu, d, "RRC (IY+d)  ");		break;
	case 0x0F: __dz80_op_ixd0(cpu, d, "RRC (IY+d),A");		break;

	case 0x10: __dz80_op_ixd0(cpu, d, "RL (IY+d),B");		break;
	case 0x11: __dz80_op_ixd0(cpu, d, "RL (IY+d),C");		break;
	case 0x12: __dz80_op_ixd0(cpu, d, "RL (IY+d),D");		break;
	case 0x13: __dz80_op_ixd0(cpu, d, "RL (IY+d),E");		break;
	case 0x14: __dz80_op_ixd0(cpu, d, "RL (IY+d),H");		break;
	case 0x15: __dz80_op_ixd0(cpu, d, "RL (IY+d),L");		break;
	case 0x16: __dz80_op_ixd0(cpu, d, "RL (IY+d)  ");		break;
	case 0x17: __dz80_op_ixd0(cpu, d, "RL (IY+d),A");		break;

	case 0x18: __dz80_op_ixd0(cpu, d, "RR (IY+d),B");		break;
	case 0x19: __dz80_op_ixd0(cpu, d, "RR (IY+d),C");		break;
	case 0x1A: __dz80_op_ixd0(cpu, d, "RR (IY+d),D");		break;
	case 0x1B: __dz80_op_ixd0(cpu, d, "RR (IY+d),E");		break;
	case 0x1C: __dz80_op_ixd0(cpu, d, "RR (IY+d),H");		break;
	case 0x1D: __dz80_op_ixd0(cpu, d, "RR (IY+d),L");		break;
	case 0x1E: __dz80_op_ixd0(cpu, d, "RR (IY+d)  ");		break;
	case 0x1F: __dz80_op_ixd0(cpu, d, "RR (IY+d),A");		break;

	case 0x20: __dz80_op_ixd0(cpu, d, "SLA (IY+d),B");		break;
	case 0x21: __dz80_op_ixd0(cpu, d, "SLA (IY+d),C");		break;
	case 0x22: __dz80_op_ixd0(cpu, d, "SLA (IY+d),D");		break;
	case 0x23: __dz80_op_ixd0(cpu, d, "SLA (IY+d),E");		break;
	case 0x24: __dz80_op_ixd0(cpu, d, "SLA (IY+d),H");		break;
	case 0x25: __dz80_op_ixd0(cpu, d, "SLA (IY+d),L");		break;
	case 0x26: __dz80_op_ixd0(cpu, d, "SLA (IY+d)  ");		break;
	case 0x27: __dz80_op_ixd0(cpu, d, "SLA (IY+d),A");		break;

	case 0x28: __dz80_op_ixd0(cpu, d, "SRA (IY+d),B");		break;
	case 0x29: __dz80_op_ixd0(cpu, d, "SRA (IY+d),C");		break;
	case 0x2A: __dz80_op_ixd0(cpu, d, "SRA (IY+d),D");		break;
	case 0x2B: __dz80_op_ixd0(cpu, d, "SRA (IY+d),E");		break;
	case 0x2C: __dz80_op_ixd0(cpu, d, "SRA (IY+d),H");		break;
	case 0x2D: __dz80_op_ixd0(cpu, d, "SRA (IY+d),L");		break;
	case 0x2E: __dz80_op_ixd0(cpu, d, "SRA (IY+d)  ");		break;
	case 0x2F: __dz80_op_ixd0(cpu, d, "SRA (IY+d),A");		break;

	case 0x30: __dz80_op_ixd0(cpu, d, "SLL (IY+d),B");		break;
	case 0x31: __dz80_op_ixd0(cpu, d, "SLL (IY+d),C");		break;
	case 0x32: __dz80_op_ixd0(cpu, d, "SLL (IY+d),D");		break;
	case 0x33: __dz80_op_ixd0(cpu, d, "SLL (IY+d),E");		break;
	case 0x34: __dz80_op_ixd0(cpu, d, "SLL (IY+d),H");		break;
	case 0x35: __dz80_op_ixd0(cpu, d, "SLL (IY+d),L");		break;
	case 0x36: __dz80_op_ixd0(cpu, d, "SLL (IY+d)  ");		break;
	case 0x37: __dz80_op_ixd0(cpu, d, "SLL (IY+d),A");		break;

	case 0x38: __dz80_op_ixd0(cpu, d, "SRL (IY+d),B");		break;
	case 0x39: __dz80_op_ixd0(cpu, d, "SRL (IY+d),C");		break;
	case 0x3A: __dz80_op_ixd0(cpu, d, "SRL (IY+d),D");		break;
	case 0x3B: __dz80_op_ixd0(cpu, d, "SRL (IY+d),E");		break;
	case 0x3C: __dz80_op_ixd0(cpu, d, "SRL (IY+d),H");		break;
	case 0x3D: __dz80_op_ixd0(cpu, d, "SRL (IY+d),L");		break;
	case 0x3E: __dz80_op_ixd0(cpu, d, "SRL (IY+d)  ");		break;
	case 0x3F: __dz80_op_ixd0(cpu, d, "SRL (IY+d),A");		break;

	case 0x40: __dz80_op_ixd0(cpu, d, "BIT 0,(IY+d),B");	break;
	case 0x41: __dz80_op_ixd0(cpu, d, "BIT 0,(IY+d),C");	break;
	case 0x42: __dz80_op_ixd0(cpu, d, "BIT 0,(IY+d),D");	break;
	case 0x43: __dz80_op_ixd0(cpu, d, "BIT 0,(IY+d),E");	break;
	case 0x44: __dz80_op_ixd0(cpu, d, "BIT 0,(IY+d),H");	break;
	case 0x45: __dz80_op_ixd0(cpu, d, "BIT 0,(IY+d),L");	break;
	case 0x46: __dz80_op_ixd0(cpu, d, "BIT 0,(IY+d)");		break;
	case 0x47: __dz80_op_ixd0(cpu, d, "BIT 0,(IY+d),A");	break;

	case 0x48: __dz80_op_ixd0(cpu, d, "BIT 1,(IY+d),B");	break;
	case 0x49: __dz80_op_ixd0(cpu, d, "BIT 1,(IY+d),C");	break;
	case 0x4A: __dz80_op_ixd0(cpu, d, "BIT 1,(IY+d),D");	break;
	case 0x4B: __dz80_op_ixd0(cpu, d, "BIT 1,(IY+d),E");	break;
	case 0x4C: __dz80_op_ixd0(cpu, d, "BIT 1,(IY+d),H");	break;
	case 0x4D: __dz80_op_ixd0(cpu, d, "BIT 1,(IY+d),L");	break;
	case 0x4E: __dz80_op_ixd0(cpu, d, "BIT 1,(IY+d)");		break;
	case 0x4F: __dz80_op_ixd0(cpu, d, "BIT 1,(IY+d),A");	break;

	case 0x50: __dz80_op_ixd0(cpu, d, "BIT 2,(IY+d),B");	break;
	case 0x51: __dz80_op_ixd0(cpu, d, "BIT 2,(IY+d),C");	break;
	case 0x52: __dz80_op_ixd0(cpu, d, "BIT 2,(IY+d),D");	break;
	case 0x53: __dz80_op_ixd0(cpu, d, "BIT 2,(IY+d),E");	break;
	case 0x54: __dz80_op_ixd0(cpu, d, "BIT 2,(IY+d),H");	break;
	case 0x55: __dz80_op_ixd0(cpu, d, "BIT 2,(IY+d),L");	break;
	case 0x56: __dz80_op_ixd0(cpu, d, "BIT 2,(IY+d)");		break;
	case 0x57: __dz80_op_ixd0(cpu, d, "BIT 2,(IY+d),A");	break;

	case 0x58: __dz80_op_ixd0(cpu, d, "BIT 3,(IY+d),B");	break;
	case 0x59: __dz80_op_ixd0(cpu, d, "BIT 3,(IY+d),C");	break;
	case 0x5A: __dz80_op_ixd0(cpu, d, "BIT 3,(IY+d),D");	break;
	case 0x5B: __dz80_op_ixd0(cpu, d, "BIT 3,(IY+d),E");	break;
	case 0x5C: __dz80_op_ixd0(cpu, d, "BIT 3,(IY+d),H");	break;
	case 0x5D: __dz80_op_ixd0(cpu, d, "BIT 3,(IY+d),L");	break;
	case 0x5E: __dz80_op_ixd0(cpu, d, "BIT 3,(IY+d)");		break;
	case 0x5F: __dz80_op_ixd0(cpu, d, "BIT 3,(IY+d),A");	break;

	case 0x60: __dz80_op_ixd0(cpu, d, "BIT 4,(IY+d),B");	break;
	case 0x61: __dz80_op_ixd0(cpu, d, "BIT 4,(IY+d),C");	break;
	case 0x62: __dz80_op_ixd0(cpu, d, "BIT 4,(IY+d),D");	break;
	case 0x63: __dz80_op_ixd0(cpu, d, "BIT 4,(IY+d),E");	break;
	case 0x64: __dz80_op_ixd0(cpu, d, "BIT 4,(IY+d),H");	break;
	case 0x65: __dz80_op_ixd0(cpu, d, "BIT 4,(IY+d),L");	break;
	case 0x66: __dz80_op_ixd0(cpu, d, "BIT 4,(IY+d)");		break;
	case 0x67: __dz80_op_ixd0(cpu, d, "BIT 4,(IY+d),A");	break;

	case 0x68: __dz80_op_ixd0(cpu, d, "BIT 5,(IY+d),B");	break;
	case 0x69: __dz80_op_ixd0(cpu, d, "BIT 5,(IY+d),C");	break;
	case 0x6A: __dz80_op_ixd0(cpu, d, "BIT 5,(IY+d),D");	break;
	case 0x6B: __dz80_op_ixd0(cpu, d, "BIT 5,(IY+d),E");	break;
	case 0x6C: __dz80_op_ixd0(cpu, d, "BIT 5,(IY+d),H");	break;
	case 0x6D: __dz80_op_ixd0(cpu, d, "BIT 5,(IY+d),L");	break;
	case 0x6E: __dz80_op_ixd0(cpu, d, "BIT 5,(IY+d)");		break;
	case 0x6F: __dz80_op_ixd0(cpu, d, "BIT 5,(IY+d),A");	break;

	case 0x70: __dz80_op_ixd0(cpu, d, "BIT 6,(IY+d),B");	break;
	case 0x71: __dz80_op_ixd0(cpu, d, "BIT 6,(IY+d),C");	break;
	case 0x72: __dz80_op_ixd0(cpu, d, "BIT 6,(IY+d),D");	break;
	case 0x73: __dz80_op_ixd0(cpu, d, "BIT 6,(IY+d),E");	break;
	case 0x74: __dz80_op_ixd0(cpu, d, "BIT 6,(IY+d),H");	break;
	case 0x75: __dz80_op_ixd0(cpu, d, "BIT 6,(IY+d),L");	break;
	case 0x76: __dz80_op_ixd0(cpu, d, "BIT 6,(IY+d)");		break;
	case 0x77: __dz80_op_ixd0(cpu, d, "BIT 6,(IY+d),A");	break;

	case 0x78: __dz80_op_ixd0(cpu, d, "BIT 7,(IY+d),B");	break;
	case 0x79: __dz80_op_ixd0(cpu, d, "BIT 7,(IY+d),C");	break;
	case 0x7A: __dz80_op_ixd0(cpu, d, "BIT 7,(IY+d),D");	break;
	case 0x7B: __dz80_op_ixd0(cpu, d, "BIT 7,(IY+d),E");	break;
	case 0x7C: __dz80_op_ixd0(cpu, d, "BIT 7,(IY+d),H");	break;
	case 0x7D: __dz80_op_ixd0(cpu, d, "BIT 7,(IY+d),L");	break;
	case 0x7E: __dz80_op_ixd0(cpu, d, "BIT 7,(IY+d)");		break;
	case 0x7F: __dz80_op_ixd0(cpu, d, "BIT 7,(IY+d),A");	break;

	case 0x80: __dz80_op_ixd0(cpu, d, "RES 0,(IY+d),B");	break;
	case 0x81: __dz80_op_ixd0(cpu, d, "RES 0,(IY+d),C");	break;
	case 0x82: __dz80_op_ixd0(cpu, d, "RES 0,(IY+d),D");	break;
	case 0x83: __dz80_op_ixd0(cpu, d, "RES 0,(IY+d),E");	break;
	case 0x84: __dz80_op_ixd0(cpu, d, "RES 0,(IY+d),H");	break;
	case 0x86: __dz80_op_ixd0(cpu, d, "RES 0,(IY+d)");		break;
	case 0x87: __dz80_op_ixd0(cpu, d, "RES 0,(IY+d),A");	break;

	case 0x88: __dz80_op_ixd0(cpu, d, "RES 1,(IY+d),B");	break;
	case 0x89: __dz80_op_ixd0(cpu, d, "RES 1,(IY+d),C");	break;
	case 0x8A: __dz80_op_ixd0(cpu, d, "RES 1,(IY+d),D");	break;
	case 0x8B: __dz80_op_ixd0(cpu, d, "RES 1,(IY+d),E");	break;
	case 0x8C: __dz80_op_ixd0(cpu, d, "RES 1,(IY+d),H");	break;
	case 0x8D: __dz80_op_ixd0(cpu, d, "RES 1,(IY+d),L");	break;
	case 0x8E: __dz80_op_ixd0(cpu, d, "RES 1,(IY+d)");		break;
	case 0x8F: __dz80_op_ixd0(cpu, d, "RES 1,(IY+d),A");	break;

	case 0x90: __dz80_op_ixd0(cpu, d, "RES 2,(IY+d),B");	break;
	case 0x91: __dz80_op_ixd0(cpu, d, "RES 2,(IY+d),C");	break;
	case 0x92: __dz80_op_ixd0(cpu, d, "RES 2,(IY+d),D");	break;
	case 0x93: __dz80_op_ixd0(cpu, d, "RES 2,(IY+d),E");	break;
	case 0x94: __dz80_op_ixd0(cpu, d, "RES 2,(IY+d),H");	break;
	case 0x95: __dz80_op_ixd0(cpu, d, "RES 2,(IY+d),L");	break;
	case 0x96: __dz80_op_ixd0(cpu, d, "RES 2,(IY+d)");		break;
	case 0x97: __dz80_op_ixd0(cpu, d, "RES 2,(IY+d),A");	break;

	case 0x98: __dz80_op_ixd0(cpu, d, "RES 3,(IY+d),B");	break;
	case 0x99: __dz80_op_ixd0(cpu, d, "RES 3,(IY+d),C");	break;
	case 0x9A: __dz80_op_ixd0(cpu, d, "RES 3,(IY+d),D");	break;
	case 0x9B: __dz80_op_ixd0(cpu, d, "RES 3,(IY+d),E");	break;
	case 0x9C: __dz80_op_ixd0(cpu, d, "RES 3,(IY+d),H");	break;
	case 0x9D: __dz80_op_ixd0(cpu, d, "RES 3,(IY+d),L");	break;
	case 0x9E: __dz80_op_ixd0(cpu, d, "RES 3,(IY+d)");		break;
	case 0x9F: __dz80_op_ixd0(cpu, d, "RES 3,(IY+d),A");	break;

	case 0xA0: __dz80_op_ixd0(cpu, d, "RES 4,(IY+d),B");	break;
	case 0xA1: __dz80_op_ixd0(cpu, d, "RES 4,(IY+d),C");	break;
	case 0xA2: __dz80_op_ixd0(cpu, d, "RES 4,(IY+d),D");	break;
	case 0xA3: __dz80_op_ixd0(cpu, d, "RES 4,(IY+d),E");	break;
	case 0xA4: __dz80_op_ixd0(cpu, d, "RES 4,(IY+d),H");	break;
	case 0xA5: __dz80_op_ixd0(cpu, d, "RES 4,(IY+d),L");	break;
	case 0xA6: __dz80_op_ixd0(cpu, d, "RES 4,(IY+d)");		break;
	case 0xA7: __dz80_op_ixd0(cpu, d, "RES 4,(IY+d),A");	break;

	case 0xA8: __dz80_op_ixd0(cpu, d, "RES 5,(IY+d),B");	break;
	case 0xA9: __dz80_op_ixd0(cpu, d, "RES 5,(IY+d),C");	break;
	case 0xAA: __dz80_op_ixd0(cpu, d, "RES 5,(IY+d),D");	break;
	case 0xAB: __dz80_op_ixd0(cpu, d, "RES 5,(IY+d),E");	break;
	case 0xAC: __dz80_op_ixd0(cpu, d, "RES 5,(IY+d),H");	break;
	case 0xAD: __dz80_op_ixd0(cpu, d, "RES 5,(IY+d),L");	break;
	case 0xAE: __dz80_op_ixd0(cpu, d, "RES 5,(IY+d)");		break;
	case 0xAF: __dz80_op_ixd0(cpu, d, "RES 5,(IY+d),A");	break;

	case 0xB0: __dz80_op_ixd0(cpu, d, "RES 6,(IY+d),B");	break;
	case 0xB1: __dz80_op_ixd0(cpu, d, "RES 6,(IY+d),C");	break;
	case 0xB2: __dz80_op_ixd0(cpu, d, "RES 6,(IY+d),D");	break;
	case 0xB3: __dz80_op_ixd0(cpu, d, "RES 6,(IY+d),E");	break;
	case 0xB4: __dz80_op_ixd0(cpu, d, "RES 6,(IY+d),H");	break;
	case 0xB5: __dz80_op_ixd0(cpu, d, "RES 6,(IY+d),L");	break;
	case 0xB6: __dz80_op_ixd0(cpu, d, "RES 6,(IY+d)");		break;
	case 0xB7: __dz80_op_ixd0(cpu, d, "RES 6,(IY+d),A");	break;

	case 0xB8: __dz80_op_ixd0(cpu, d, "RES 7,(IY+d),B");	break;
	case 0xB9: __dz80_op_ixd0(cpu, d, "RES 7,(IY+d),C");	break;
	case 0xBA: __dz80_op_ixd0(cpu, d, "RES 7,(IY+d),D");	break;
	case 0xBB: __dz80_op_ixd0(cpu, d, "RES 7,(IY+d),E");	break;
	case 0xBC: __dz80_op_ixd0(cpu, d, "RES 7,(IY+d),H");	break;
	case 0xBD: __dz80_op_ixd0(cpu, d, "RES 7,(IY+d),L");	break;
	case 0xBE: __dz80_op_ixd0(cpu, d, "RES 7,(IY+d)");		break;
	case 0xBF: __dz80_op_ixd0(cpu, d, "RES 7,(IY+d),A");	break;

	case 0xC0: __dz80_op_ixd0(cpu, d, "SET 0,(IY+d),B");	break;
	case 0xC1: __dz80_op_ixd0(cpu, d, "SET 0,(IY+d),C");	break;
	case 0xC2: __dz80_op_ixd0(cpu, d, "SET 0,(IY+d),D");	break;
	case 0xC3: __dz80_op_ixd0(cpu, d, "SET 0,(IY+d),E");	break;
	case 0xC4: __dz80_op_ixd0(cpu, d, "SET 0,(IY+d),H");	break;
	case 0xC6: __dz80_op_ixd0(cpu, d, "SET 0,(IY+d)");		break;
	case 0xC7: __dz80_op_ixd0(cpu, d, "SET 0,(IY+d),A");	break;

	case 0xC8: __dz80_op_ixd0(cpu, d, "SET 1,(IY+d),B");	break;
	case 0xC9: __dz80_op_ixd0(cpu, d, "SET 1,(IY+d),C");	break;
	case 0xCA: __dz80_op_ixd0(cpu, d, "SET 1,(IY+d),D");	break;
	case 0xCB: __dz80_op_ixd0(cpu, d, "SET 1,(IY+d),E");	break;
	case 0xCC: __dz80_op_ixd0(cpu, d, "SET 1,(IY+d),H");	break;
	case 0xCD: __dz80_op_ixd0(cpu, d, "SET 1,(IY+d),L");	break;
	case 0xCE: __dz80_op_ixd0(cpu, d, "SET 1,(IY+d)");		break;
	case 0xCF: __dz80_op_ixd0(cpu, d, "SET 1,(IY+d),A");	break;

	case 0xD0: __dz80_op_ixd0(cpu, d, "SET 2,(IY+d),B");	break;
	case 0xD1: __dz80_op_ixd0(cpu, d, "SET 2,(IY+d),C");	break;
	case 0xD2: __dz80_op_ixd0(cpu, d, "SET 2,(IY+d),D");	break;
	case 0xD3: __dz80_op_ixd0(cpu, d, "SET 2,(IY+d),E");	break;
	case 0xD4: __dz80_op_ixd0(cpu, d, "SET 2,(IY+d),H");	break;
	case 0xD6: __dz80_op_ixd0(cpu, d, "SET 2,(IY+d)");		break;
	case 0xD7: __dz80_op_ixd0(cpu, d, "SET 2,(IY+d),A");	break;

	case 0xD8: __dz80_op_ixd0(cpu, d, "SET 3,(IY+d),B");	break;
	case 0xD9: __dz80_op_ixd0(cpu, d, "SET 3,(IY+d),C");	break;
	case 0xDA: __dz80_op_ixd0(cpu, d, "SET 3,(IY+d),D");	break;
	case 0xDB: __dz80_op_ixd0(cpu, d, "SET 3,(IY+d),E");	break;
	case 0xDC: __dz80_op_ixd0(cpu, d, "SET 3,(IY+d),H");	break;
	case 0xDD: __dz80_op_ixd0(cpu, d, "SET 3,(IY+d),L");	break;
	case 0xDE: __dz80_op_ixd0(cpu, d, "SET 3,(IY+d)");		break;
	case 0xDF: __dz80_op_ixd0(cpu, d, "SET 3,(IY+d),A");	break;

	case 0xE0: __dz80_op_ixd0(cpu, d, "SET 4,(IY+d),B");	break;
	case 0xE1: __dz80_op_ixd0(cpu, d, "SET 4,(IY+d),C");	break;
	case 0xE2: __dz80_op_ixd0(cpu, d, "SET 4,(IY+d),D");	break;
	case 0xE3: __dz80_op_ixd0(cpu, d, "SET 4,(IY+d),E");	break;
	case 0xE4: __dz80_op_ixd0(cpu, d, "SET 4,(IY+d),H");	break;
	case 0xE6: __dz80_op_ixd0(cpu, d, "SET 4,(IY+d)");		break;
	case 0xE7: __dz80_op_ixd0(cpu, d, "SET 4,(IY+d),A");	break;

	case 0xE8: __dz80_op_ixd0(cpu, d, "SET 5,(IY+d),B");	break;
	case 0xE9: __dz80_op_ixd0(cpu, d, "SET 5,(IY+d),C");	break;
	case 0xEA: __dz80_op_ixd0(cpu, d, "SET 5,(IY+d),D");	break;
	case 0xEB: __dz80_op_ixd0(cpu, d, "SET 5,(IY+d),E");	break;
	case 0xEC: __dz80_op_ixd0(cpu, d, "SET 5,(IY+d),H");	break;
	case 0xED: __dz80_op_ixd0(cpu, d, "SET 5,(IY+d),L");	break;
	case 0xEE: __dz80_op_ixd0(cpu, d, "SET 5,(IY+d)");		break;
	case 0xEF: __dz80_op_ixd0(cpu, d, "SET 5,(IY+d),A");	break;

	case 0xF0: __dz80_op_ixd0(cpu, d, "SET 6,(IY+d),B");	break;
	case 0xF1: __dz80_op_ixd0(cpu, d, "SET 6,(IY+d),C");	break;
	case 0xF2: __dz80_op_ixd0(cpu, d, "SET 6,(IY+d),D");	break;
	case 0xF3: __dz80_op_ixd0(cpu, d, "SET 6,(IY+d),E");	break;
	case 0xF4: __dz80_op_ixd0(cpu, d, "SET 6,(IY+d),H");	break;
	case 0xF6: __dz80_op_ixd0(cpu, d, "SET 6,(IY+d)");		break;
	case 0xF7: __dz80_op_ixd0(cpu, d, "SET 6,(IY+d),A");	break;

	case 0xF8: __dz80_op_ixd0(cpu, d, "SET 7,(IY+d),B");	break;
	case 0xF9: __dz80_op_ixd0(cpu, d, "SET 7,(IY+d),C");	break;
	case 0xFA: __dz80_op_ixd0(cpu, d, "SET 7,(IY+d),D");	break;
	case 0xFB: __dz80_op_ixd0(cpu, d, "SET 7,(IY+d),E");	break;
	case 0xFC: __dz80_op_ixd0(cpu, d, "SET 7,(IY+d),H");	break;
	case 0xFD: __dz80_op_ixd0(cpu, d, "SET 7,(IY+d),L");	break;
	case 0xFE: __dz80_op_ixd0(cpu, d, "SET 7,(IY+d)");		break;
	case 0xFF: __dz80_op_ixd0(cpu, d, "SET 7,(IY+d),A");	break;
	}
}
#ifdef __cplusplus
}	// extern "C"
#endif
