/**--------------------------------------------------------------------------
 **
 **		NEC PC-8001 Emulator "N80" for Win32/DirectX
 **		--------------------------------------------
 **		Copyright (c) 1993-2010 H.Kanemoto
 **
 **		Z80 Thread
 **
 **		Rev		Date		Descriptions
 **		-----	----------	-----------------------------------------------
 **		1.00	1996/06/27	porting DOS version on WinG
 **		1.20	1997/08/10	porting WinG version on Win32/DirectX
 **		1.30	1998/03/12	
 **		1.43	2007/09/01	XPΉ
 **		1.44	2009/12/15	Vista/7Ή
 **		1.51	2010/01/27	DirectSound OnlyɕύX
 **------------------------------------------------------------------------*/
#include "z80_thread.h"
#include "../n80/n80_directx.h"
#include "../n80/n80_form.h"
#include <math.h>
#include <stdio.h>
/**--------------------------------------------------------------------------
 **		O[oϐ
 **------------------------------------------------------------------------*/
extern DWORD_PTR	affinity;
extern n80_assay	*assay;
extern n80_directx	*dx;
extern n80_form		*form;
/**--------------------------------------------------------------------------
 **		RXgN^^fXgN^
 **------------------------------------------------------------------------*/
z80_thread::z80_thread() : icj_thread() {
	m_interlock = 0;
	m_sys_Ts = 0;
	m_z80_paused  = FALSE;
	n80win32.m_z80_no_wait = FALSE;
	m_render = NULL;
}

z80_thread::~z80_thread() {
	assay->outputLog(TEXT("ENTER ~z80_thread"));
	if (isRunning())
		kill();
	if (m_render != NULL) {
		m_render->postMessage(WM_QUIT, 0, 0);
		m_render->kill();
		delete m_render;
		m_render = NULL;
	}
	if (m_hevt_sync != NULL) {
		::CloseHandle(m_hevt_sync);
		m_hevt_sync = NULL;
	}
	if (m_hevt_ack != NULL) {
		::CloseHandle(m_hevt_ack);
		m_hevt_ack = NULL;
	}
	if (m_hevt_sync != NULL) {
		::CloseHandle(m_hevt_sync_ren);
		m_hevt_sync = NULL;
	}
	if (m_hevt_ack != NULL) {
		::CloseHandle(m_hevt_ack_ren);
		m_hevt_ack = NULL;
	}
	if (m_timer != NULL) {
		::CloseHandle(m_timer);
		m_timer = NULL;
	}
	assay->outputLog(TEXT("LEAVE ~z80_thread"));
}
BOOL
z80_thread::init() {
	// Cxg擾
	m_hevt_sync = ::OpenEvent(EVENT_ALL_ACCESS, FALSE, "SYNC");
	m_hevt_ack = ::OpenEvent(EVENT_ALL_ACCESS, FALSE, "ACK");
	m_hevt_sync_ren	= ::CreateEvent(NULL, FALSE, FALSE, "SYNC_REN");
	m_hevt_ack_ren	= ::CreateEvent(NULL, FALSE, FALSE, "ACK_REN");

	// `惌_[
	m_render = new n80_render();

	// Xe[g^C}[
	m_timer = CreateWaitableTimer(NULL, TRUE, NULL);
	if (m_timer == NULL) {
		assay->outputLog(TEXT("Z80 WaitTimer쐬s"));
		return false;
	}
	return true;
}
/**--------------------------------------------------------------------------
 **		Xbh[`{
 **------------------------------------------------------------------------*/
void
z80_thread::enter() {
	Z80CPU& cpu = n80device.cpu;
	// RenderXbh
	m_render->start(false);

	// Thread蓖ProcessorŒ肷
	if (!::SetThreadAffinityMask(::GetCurrentThread(), affinity & 2 ? 2 : 1)) {
		assay->outputLog(TEXT("Z80 ThreadŒ(%d)s"), affinity & 2 ? 2 : 1);
		if (!::SetThreadAffinityMask(::GetCurrentThread(), 1))
			assay->outputLog(TEXT("Z80 ThreadŒ(%d)s"), 1);
		else
			assay->outputLog(TEXT("Z80 ThreadŒ(%d)"), 1);
	} else
		assay->outputLog(TEXT("Z80 ThreadŒ(%d)"), affinity & 2 ? 2 : 1);

	// uPD780(Z80)Xe[g݌v
	UINT state_cnt   = 0;
	long sync_T = 0;	// main <=> sub cpu state adjust count
	::Sleep(1000);

	// DirectSoundĐJn
	dx->play();

	double est_time = n80device.get_tick() + IVLSEC;
	// Fetch[vJn
	for (UINT tk = 0, loop_cnt = 0;; ++tk) {
		if ((tk & 0xff) == 0) {
			// ~ṽ`FbN
			#if _MSC_VER <= 1200
			LPVOID prev_interlock = ::InterlockedCompareExchange((PVOID*) &m_interlock, 0, (LPVOID) 1);
			if (prev_interlock == (LPVOID) 1)
			#else
			LONG prev_interlock = ::InterlockedCompareExchange(&m_interlock, 0, 1);
			if (prev_interlock == 1)
			#endif
			{
				// 1) ~CxgM
				::SetEvent(m_hevt_ack);
				m_z80_paused = TRUE;
				assay->outputLog(TEXT("Z80: accept thread pause."));

				// 2) ĊJ҂
				::WaitForSingleObject(m_hevt_sync, INFINITE);

				// 3) IvmF 2)-3)̊ԂɏIv̓Zbg
				if (m_interlock == 2) {
					assay->outputLog(TEXT("Z80: thread resume and quit!"));
					return;
				}
				assay->outputLog(TEXT("Z80: resume thread"));

				// 4) ~̃EFCgJEgNA
				state_cnt = 0;
				est_time = n80device.get_tick() + IVLSEC;
				m_z80_paused = FALSE;
			}
		}
		cpu.r.x.T	 = 0;
		cpu.r.x.TwM1 = 0;
		cpu.r.x.W	 = 0;
		cpu.r.x.Wh	 = 0;
		sync_T = 0;

		// Z80ߎs
		if (n80device.dmac._penarty > 0) {
			if (n80device.dmac._penarty > 2) {
				cpu.r.x.T += 2;
				n80device.dmac._penarty -= 2;
			} else {
				cpu.r.x.T += n80device.dmac._penarty;
				n80device.dmac._penarty = 0;
			}
		} else {
			cpu.extrn_sync_clk = tk;
			cpu.step(&cpu);
			if (cpu.halt_detect && cpu.r.x.HALT != _Z80HALT_76) {
				assay->outputLog(TEXT("Z80 (MAIN): detect HALT signal!"));
				form->postMessage(WM_HALT_DETECT, (WPARAM)&n80device.cpu, (LPARAM)0);
				if (cpu.r.x.HALT != _Z80HALT_76 && !cpu.dbgctx.debug_enable)
					this->reset();
			}
			sync_T = cpu.r.x.T + cpu.r.x.TwM1;
		}
		// EFCgXe[gɉZ
		if (!n80win32.m_z80_no_wait)
			cpu.r.x.T += (cpu.r.x.W + cpu.r.x.Wh + cpu.r.x.TwM1);
		else
			cpu.r.x.T += cpu.r.x.TwM1;

		// SUB CPU STEPs
		n80device.fdu.cpu.extrn_sync_clk = tk;
		n80device.fdu.cpu_sync_T += sync_T;
		if (n80device.fdu.cpu_sync_T > 0)
			n80device.fdu.cpu.step(&n80device.fdu.cpu);

		// ^\^C~O
		int vrtc = n80device.vrtc.blanking(&cpu);
		if (vrtc == _VRTC_VBBGN) {			// AJn
			;
		} else if (vrtc == _VRTC_VBEND) {	// AI
			m_render->postMessage(WM_REQ_DRAW, 0, 0);	// `˗
		}

		// Ӌ@폈
		::InterlockedExchangeAdd(&m_sys_Ts, cpu.r.x.T);
		n80device.dispatch(&n80device);

		// Beep/PCGԊuXe[gݐ
		n80device.snd.append_ticks(cpu.r.x.T);

		// Xe[g(T)݌v20ms𒴉߂_ŃEFCg
		state_cnt += cpu.r.x.T;
		if (state_cnt >= n80device.param.sync_ticks) {
			int i = 0;
			++n80win32.loop_cnt;
			LPCBYTE pcm = dx->makepcm();
			dx->feedpcm(pcm);
			while (1) {
				volatile double cur_time = n80device.get_tick();
				volatile double remain_tick = est_time - cur_time;
				if (i++ == 0) {
					n80win32.remain_ticks_top_sum += remain_tick;
					if (remain_tick < 0)
						++n80win32.remain_top_minus_cnt;
				}
				if (remain_tick >= 0.016) {
					::Sleep(8);
				} else if (remain_tick >= 0.012) {
					::Sleep(4);
				} else if (remain_tick >= 0.005) {
					::Sleep(0);
				} else {
					cur_time = n80device.get_tick();
					remain_tick = est_time - cur_time;
					n80win32.remain_ticks_sum += remain_tick;
					if (remain_tick < 0) {
						if (remain_tick < -0.010)
							est_time = cur_time + IVLSEC;
						else
							est_time += IVLSEC;
						++n80win32.remain_minus_cnt;
						n80win32.remain_minus_sum += remain_tick;
					} else {
						est_time += IVLSEC;
					}
					state_cnt -= n80device.param.sync_ticks;
					break;
				}
			}
		}
	}
}
/**--------------------------------------------------------------------------
 **		iOThreadĂяoj
 **------------------------------------------------------------------------*/
BOOL
z80_thread::sync(WPARAM verb) {
	// z80 thread`FbN
	if (!isRunning ()) {
		return FALSE;
	}
	// renderꎞ~
	m_render->sync(verb);

	// z80 threadɓ~v
	::ResetEvent(m_hevt_sync);
	::ResetEvent(m_hevt_ack);
	::InterlockedExchange(&m_interlock, 1);

	// z80 thread̓mF(Wait Max 5sec)
	if (::WaitForSingleObject(m_hevt_ack, 5000) != WAIT_OBJECT_0) {
		kill();
		return FALSE;
	} else
		return TRUE;
}

void
z80_thread::desync() {
	// render thread̓~
	m_render->desync();

	// z80 thread̓~
	::SetEvent(m_hevt_sync);
}
/**--------------------------------------------------------------------------
 **		O
 **------------------------------------------------------------------------*/
void
z80_thread::reset() {
	n80device.cpu.reset(&n80device.cpu);
	n80win32.remain_ticks_top_sum = 0;
	n80win32.remain_ticks_sum = 0;
	n80win32.remain_minus_sum = 0;
	n80win32.remain_top_minus_cnt = 0;
	n80win32.remain_minus_cnt = 0;
	n80win32.loop_cnt = 0;
}

void
z80_thread::exit() {
	::InterlockedExchange(&m_interlock, 2);
}

void
z80_thread::restart(WORD pc, WORD sp) {
	n80device.cpu.r.x.PC = pc;
	n80device.cpu.r.x.SP = sp;
}
/**--------------------------------------------------------------------------
 **		WX^擾
 **------------------------------------------------------------------------*/
USHORT
z80_thread::getRegister(int index) {
	return  n80device.cpu.r.xr[index];
}
