//
//		IICCJ Class Library Ver 1.00
//		iiccj a
//
//		敪F  LFȂ  nrF95/NT  FC++
//		-----------------------------------------------
//		  	F	BitMap (DIB) Object
//		NXF	icj_dib
//		  I	F	
//		File敪F	NX(.cpp)
//		쐬	F	{ mu
//
//		Rev		t			ύX_
//		-----	----------	----------------------------------------------
//		1.0.0	1997.05.31	
//		1.0.1	1997.06.14	Ǝ̃֐gp
//		1.0.2	1997.12.07	icj_class ɑgݍ
//
#include "icj_dib.h"
#include "icj_dib_pal.h"
#include "icj_memory.h"
#include <crtdbg.h>
///////////////////////////////////////////////////////////////////////////////
//	RXgN^^fXgN^
///////////////////////////////////////////////////////////////////////////////
icj_dib::icj_dib ()
{
	initVars ();
}

icj_dib::~icj_dib ()
{
	detach ();
}

///////////////////////////////////////////////////////////////////////////////
//	^I֐
///////////////////////////////////////////////////////////////////////////////
void
icj_dib::initVars ()
{
	m_type	  = -1;
	m_bmfh	  = NULL;		// BITMAPFILEHEADER
	m_bmi	  = NULL;		// BITMAPINFO
	m_bmih	  = NULL;		// BITMAPINFOHEADER
	m_quad	  = NULL;		// RGBQUAD
	m_quads	  = 0;
	m_bytes   = NULL;		// rbgf[^
	m_topdown = FALSE;		// {gAbvi[^iftHgj
	m_ronly	  = TRUE;		// ǂݏop
	m_lpal	  = NULL;
	m_pal	  = NULL;
	m_file	  = INVALID_HANDLE_VALUE;
	m_fmap	  = NULL;
	m_attached= FALSE;
}

void
icj_dib::detach ()
{
	switch (m_type)
	{
	case  BMFILE:
		::UnmapViewOfFile (m_bmfh);
		::CloseHandle (m_fmap);
		::CloseHandle (m_file);
		break;
	case  BMDIBSECT:
		if (m_bmi != NULL)
		{
			_RPT0 (_CRT_WARN, ">icj_dib: BITMAPINFO\n");
			xfree (m_bmi);
		}
		break;
	}
	if (m_lpal != NULL)
	{
		_RPT0 (_CRT_WARN, ">icj_dib: LOGPALETTE\n");
		xfree (m_lpal);
	}
	initVars ();
}

///////////////////////////////////////////////////////////////////////////////
//	rbg}bv
///////////////////////////////////////////////////////////////////////////////
BOOL
icj_dib::attach (const char *filename)
{
	if (m_attached)
		return  FALSE;
	try
	{
		DWORD	filsiz;

		m_type = BMFILE;
		//
		//	Bitmap t@CJ
		m_file = ::CreateFile (filename, GENERIC_READ | GENERIC_WRITE,
							   FILE_SHARE_READ, NULL, OPEN_EXISTING,
							   FILE_ATTRIBUTE_NORMAL, (HANDLE) NULL);
		if (INVALID_HANDLE_VALUE == m_file)
			throw  int (1);

		filsiz = ::GetFileSize (m_file, NULL);
		//
		//	t@C}bsOJ[l Object 
		m_fmap = ::CreateFileMapping (m_file, NULL, PAGE_WRITECOPY,
														0, filsiz, NULL);
		if (NULL == m_fmap)
			throw  int (2);
		//
		//	t@C}bsO
		m_bmfh = (LPBITMAPFILEHEADER) ::MapViewOfFile (m_fmap,
											FILE_MAP_COPY, 0, 0, filsiz);
		if (m_bmfh == NULL)
			throw  int (3);

		if (m_bmfh->bfType != 'MB')
			throw  int (4);

		m_bmi   = (LPBITMAPINFO) ((DWORD) m_bmfh + sizeof (BITMAPFILEHEADER));
		m_bmih  = &m_bmi->bmiHeader;
		m_quad  = &m_bmi->bmiColors[0];
		m_bytes = (LPBYTE) ((DWORD) m_bmfh + m_bmfh->bfOffBits);
		m_width = m_bmih->biWidth;
		m_height= m_bmih->biHeight;
		m_pitch = calcPitch ();
		if (m_height < 0)
		{
			m_height  *= -1;
			m_topdown = TRUE;
		}
		if (m_bmih->biClrUsed == 0)
		{
			switch (m_bmih->biBitCount)
			{
			case 1:		m_quads = 2;	break;
			case 4:		m_quads = 16;	break;
			case 8:		m_quads = 256;	break;
			case 24:	m_quads = 0;	break;
			default:	throw int (5);	break;
			}
		}
		else
			m_quads = m_bmih->biClrUsed;
		//
		//	pbgϊ
		if (!quad2palette ())
			throw  int (5);
	}
	catch (int e)
	{
		(void) e;
		detach ();
		return  FALSE;
	}
	m_attached = TRUE;
	return  TRUE;
}

BOOL
icj_dib::attach (WORD resid)
{
	if (m_attached)
		return  FALSE;
	try
	{
		HGLOBAL	bm;
		HRSRC	rc;
		DWORD	bitoff;

		m_type = BMRESOURCE;
		rc = ::FindResource (NULL, MAKEINTRESOURCE (resid), RT_BITMAP);
		bm = ::LoadResource (NULL, rc);
		m_bmi = (LPBITMAPINFO) ::LockResource (bm);
		if (m_bmi == NULL)
			throw  int (6);

		m_bmih   = &m_bmi->bmiHeader;
		m_quad   = &m_bmi->bmiColors[0];
		m_width  = m_bmih->biWidth;
		m_height = m_bmih->biHeight;
		m_pitch  = calcPitch ();
		if ((int) m_height < 0)
		{
			m_height  = (DWORD) ((int) m_height * -1);
			m_topdown = TRUE;
		}
		if (m_bmih->biClrUsed == 0)
		{
			switch (m_bmih->biBitCount)
			{
			case 1:		m_quads = 2;	break;
			case 4:		m_quads = 16;	break;
			case 8:		m_quads = 256;	break;
			case 24:	m_quads = 0;	break;
			default:	throw int (4);	break;
			}
		}
		else
			m_quads = m_bmih->biClrUsed;
		bitoff  = sizeof (BITMAPINFOHEADER) + sizeof (RGBQUAD) * m_quads;
		m_bytes = (LPBYTE) ((DWORD) m_bmi + bitoff);
		if (!quad2palette ())
			throw  int (5);
	}
	catch (int e)
	{
		(void) e;
		detach ();
		return  FALSE;
	}
	m_attached = TRUE;
	return  TRUE;
}
///////////////////////////////////////////////////////////////////////////////
//	rbg}bv
///////////////////////////////////////////////////////////////////////////////
LPBITMAPINFO
icj_dib::create (int width, int height, int depth, LPRGBQUAD quad, int quads)
{
	DWORD	bmisiz;
	int		maxtbl;

	if (m_attached)
		return  FALSE;
	//
	//	`FbN
	if ((quad != NULL && quads == 0) ||
		(quad == NULL && quads != 0))
		return  NULL;
	switch (depth)
	{
	case 1:		maxtbl = 2;		break;
	case 4:		maxtbl = 16;	break;
	case 8:		maxtbl = 256;	break;
	case 24:	maxtbl = quads;	break;	//  RGBQUAD w肪ꍇ̂
	default:	return  NULL;	break;
	}
	if (quads > maxtbl)
		return  NULL;

	bmisiz = sizeof (BITMAPINFOHEADER) + sizeof (RGBQUAD) * maxtbl;
	m_bmi = (LPBITMAPINFO) xmalloc (bmisiz);
	if (m_bmi == NULL)
		return  NULL;

	memset ((LPVOID) m_bmi, 0, bmisiz);
	m_bmih = &m_bmi->bmiHeader;
	m_quad = &m_bmi->bmiColors[0];
	m_bmih->biWidth    = width;
	m_bmih->biHeight   = - height;
	m_bmih->biSize     = sizeof (BITMAPINFOHEADER);
	m_bmih->biPlanes   = 1;
	m_bmih->biBitCount = depth;
	m_quads   = maxtbl;
	m_width   = width;
	m_height  = height;
	m_pitch   = calcPitch ();
	if (quad == NULL)
	{
		setDefQuad (depth, m_quad);
		m_bmih->biClrUsed  = 0;
	}
	else
	{
		for (int i = 0; i < quads; ++ i)
		{
			m_quad[i].rgbBlue	  = quad[i].rgbBlue;
			m_quad[i].rgbGreen	  = quad[i].rgbGreen;
			m_quad[i].rgbRed	  = quad[i].rgbRed;
			m_quad[i].rgbReserved = quad[i].rgbReserved;
		}
		m_bmih->biClrUsed  = depth == 24 ? maxtbl : 0;
	}
	m_type = BMDIBSECT;
	m_attached = TRUE;
	m_topdown  = TRUE;
	m_ronly    = FALSE;
	if (!quad2palette ())
	{
		detach ();
		return  NULL;
	}
	_RPT0 (_CRT_WARN, ">icj_dib: BITMAPINFOm\n");
	return  m_bmi;
}

///////////////////////////////////////////////////////////////////////////////
//	rbg֐
///////////////////////////////////////////////////////////////////////////////
static const BYTE  mask[2][8] = {
	{0x01,0x02,0x04,0x08,0x10,0x20,0x40,0x80},
	{0xfe,0xfd,0xfb,0xf7,0xef,0xdf,0x7f,0x7f}};

BOOL
icj_dib::setBit (int x, int y, DWORD data)
{
	int		offset, bit;

	if (!m_attached || m_ronly || m_bytes == NULL)
		return  FALSE;
	if ((x < 0 || x >= m_width) ||
		(y < 0 || y >= m_height))
		return  FALSE;
	offset = (m_topdown ? y : m_height - y - 1) * m_pitch;
	switch (m_bmih->biBitCount)
	{
	case  1:
		offset += x / 8;	bit = x % 8;
		if (data & 1)
			m_bytes[offset] |= mask[0][bit];
		else
			m_bytes[offset] &= mask[1][bit];
		break;
	case  4:
		offset += x / 2;	bit = x % 2;
		if (bit == 0)
		{
			m_bytes[offset] &= 0x0f;
			m_bytes[offset] |= (BYTE) ((data << 4) & 0xf0);
		}
		else
		{
			m_bytes[offset] &= 0xf0;
			m_bytes[offset] |= (BYTE) (data & 0x0f);
		}
		break;
	case  8:
		offset += x;
		m_bytes[offset] = (BYTE) data;
		break;
	case 24:
		return  FALSE;
	}
	return  TRUE;
}

COLORREF
icj_dib::getBit (int x, int y)
{
	int			offset;//, bit;
	COLORREF	rgb = 0;

	if (!m_attached || m_bytes == NULL)
		return  0;
	if ((x < 0 || x >= m_width) || (y < 0 || y >= m_height))
		return  0;
	offset = (m_topdown ? y : m_height - y - 1) * m_pitch;
	switch (m_bmih->biBitCount)
	{
	case  1:
//		offset += x / 8;	bit = x % 8;
//		if (data & 1)
//			m_bytes[offset] |= mask[0][bit];
//		else
//			m_bytes[offset] &= mask[1][bit];
		break;
	case  4:
//		offset += x / 2;	bit = x % 2;
//		if (bit == 0)
//		{
//			m_bytes[offset] &= 0x0f;
//			m_bytes[offset] |= (BYTE) ((data << 4) & 0xf0);
//		}
//		else
//		{
//			m_bytes[offset] &= 0xf0;
//			m_bytes[offset] |= (BYTE) (data & 0x0f);
//		}
		break;
	case  8:
//		offset += x;
//		m_bytes[offset] = (BYTE) data;
		break;
	case 24:
		offset += (x * 3);
		rgb = RGB(m_bytes[offset+2], m_bytes[offset+1], m_bytes[offset]);
		break;
	}
	return  rgb;
}

///////////////////////////////////////////////////////////////////////////////
//	pbgǗ
///////////////////////////////////////////////////////////////////////////////
BOOL
icj_dib::quad2palette ()
{
	DWORD  palsiz = sizeof (LOGPALETTE) + sizeof (PALETTEENTRY) * m_quads;

	if (m_quads == 0)
		return  TRUE;

	m_lpal = (LPLOGPALETTE) xmalloc (palsiz);
	if (m_lpal == NULL)
		return  FALSE;

	_RPT0 (_CRT_WARN, ">icj_dib: LOGPALETTEm\n");
	m_lpal->palVersion    = 0x300;
	m_lpal->palNumEntries = m_quads;
	m_pal = &m_lpal->palPalEntry[0];
	for (int i = 0; i < m_quads; ++ i)
	{
		m_pal[i].peRed   = m_quad[i].rgbRed;
		m_pal[i].peGreen = m_quad[i].rgbGreen;
		m_pal[i].peBlue  = m_quad[i].rgbBlue;
		m_pal[i].peFlags = PC_NOCOLLAPSE;
	}
	return  TRUE;
}

///////////////////////////////////////////////////////////////////////////////
//	wp[֐
///////////////////////////////////////////////////////////////////////////////
int
icj_dib::calcPitch ()
{
	int pitch;

	switch (m_bmih->biBitCount)
	{
	case 1:		pitch = (m_width / 8) + ((m_width % 8) == 0 ? 0 : 1);
				break;
	case 4:		pitch = (m_width / 2) + ((m_width % 2) == 0 ? 0 : 1);
				break;
	case 8:		pitch = m_width;		break;
	case 24:	pitch = m_width * 3; 	break;
	default:	pitch = 0;				break;
	}
	return  (pitch + 3) & 0xfffffffc;
}

BOOL
icj_dib::setDefQuad (int depth, LPRGBQUAD quad)
{
	int  i;

	if (quad == NULL)	return  FALSE;
	switch (depth)
	{
	case 1:	for (i = 0; i < 2; ++ i)
			{
				quad[i].rgbBlue		= win2[i][2];
				quad[i].rgbGreen	= win2[i][1];
				quad[i].rgbRed		= win2[i][0];
				quad[i].rgbReserved = 0;
			}
			break;
	case 4:	for (i = 0; i < 16; ++ i)
			{
				quad[i].rgbBlue		= win16[i][2];
				quad[i].rgbGreen	= win16[i][1];
				quad[i].rgbRed		= win16[i][0];
				quad[i].rgbReserved = 0;
			}
			break;
	case 8:	for (i = 0; i < 256; ++ i)
			{
				quad[i].rgbBlue		= win256[i][2];
				quad[i].rgbGreen	= win256[i][1];
				quad[i].rgbRed		= win256[i][0];
				quad[i].rgbReserved = 0;
			}
			break;
	default:
			return  FALSE;	break;
	}
	return  TRUE;
}

BOOL
icj_dib::setDefEntry (int depth, LPPALETTEENTRY entry)
{
	int  i;

	if (entry == NULL)	return  FALSE;
	switch (depth)
	{
	case 1:	for (i = 0; i < 2; ++ i)
			{
				entry[i].peBlue	 = win2[i][2];
				entry[i].peGreen = win2[i][1];
				entry[i].peRed	 = win2[i][0];
				entry[i].peFlags = PC_NOCOLLAPSE;
			}
			break;
	case 4:	for (i = 0; i < 16; ++ i)
			{
				entry[i].peBlue	 = win16[i][2];
				entry[i].peGreen = win16[i][1];
				entry[i].peRed	 = win16[i][0];
				entry[i].peFlags = PC_NOCOLLAPSE;
			}
			break;
	case 8:	for (i = 0; i < 256; ++ i)
			{
				entry[i].peBlue	 = win256[i][2];
				entry[i].peGreen = win256[i][1];
				entry[i].peRed	 = win256[i][0];
				entry[i].peFlags = PC_NOCOLLAPSE;
			}
			break;
	default:
			return  FALSE;	break;
	}
	return  TRUE;
}

///////////////////////////////////////////////////////////////////////////////
//	vpeB֐
///////////////////////////////////////////////////////////////////////////////
LPPALETTEENTRY
icj_dib::getPalEntry ()
{
	return  m_attached ? m_pal : NULL;
}

LPLOGPALETTE
icj_dib::getLogPal ()
{
	return  m_attached ? m_lpal : NULL;
}

LPBYTE
icj_dib::getBytes ()
{
	return  m_attached ? m_bytes : NULL;
}

BOOL
icj_dib::setBytes (LPBYTE bytes)
{
	if (m_type == BMDIBSECT)
	{
		m_bytes = bytes;
		return  TRUE;
	}
	return  FALSE;
}

int
icj_dib::getWidth ()
{
	return  m_attached ? m_width : 0;
}

int
icj_dib::getHeight ()
{
	return  m_attached ? m_height : 0;
}

int
icj_dib::getPitch ()
{
	return  m_attached ? m_pitch : 0;
}

int
icj_dib::getDepth ()
{
	return  m_attached ? m_bmih->biBitCount : 0;
}

LPBITMAPINFO
icj_dib::getBmpinfo ()
{
	return  m_bmi;
}
