//
//		IICCJ Class Library Ver 1.00
//		iiccj a
//
//		敪F  LFȂ  nrF95/NT  FC++
//		-----------------------------------------------
//		  	F	Xg[NXit@Cj
//		NXF	icj_fstream
//		  I	F	
//		File敪F	NX(.cpp)
//		쐬	F	{ mu
//
//		Rev		t			ύX_
//		-----	----------	----------------------------------------------
//		1.0.0	1998.03.22	
//
#include "icj_stream.h"
#include "icj_memory.h"
#include "icj_exception.h"

///////////////////////////////////////////////////////////////////////////////
//	RXgN^^fXgN^
///////////////////////////////////////////////////////////////////////////////
icj_fstream::icj_fstream ()
{
	init ();
}

icj_fstream::~icj_fstream ()
{
	close ();
}

///////////////////////////////////////////////////////////////////////////////
//	^I
///////////////////////////////////////////////////////////////////////////////
void
icj_fstream::init ()
{
	m_hfile = INVALID_HANDLE_VALUE;
	m_close = TRUE;
	m_purge = FALSE;
	m_ronly = FALSE;
}

BOOL
icj_fstream::close ()
{
	if (m_hfile == INVALID_HANDLE_VALUE)
		return  TRUE;
	if (m_close)
	{
		::CloseHandle (m_hfile);
		if (m_purge && m_fname)
			::DeleteFile (m_fname);
	}
	if (m_fname)
	{
		xfree (m_fname);
		m_fname = NULL;
	}
	init ();
	return  TRUE;
}

///////////////////////////////////////////////////////////////////////////////
//	q^v
///////////////////////////////////////////////////////////////////////////////
DWORD
icj_fstream::read (LPVOID buff, DWORD size, DWORD count)
{
	DWORD	rsiz;

	if (m_hfile == INVALID_HANDLE_VALUE)
		throw  icj_exception (ICJ_STREAM, ERR_INVALID_HANDLE);
	if (!::ReadFile (m_hfile, buff, size * count, &rsiz, NULL))
		throw  icj_exception (ICJ_STREAM, ERR_FILE_READ);
	return  rsiz;
}

DWORD
icj_fstream::write (LPVOID buff, DWORD size, DWORD count)
{
	DWORD	wsiz;

	if (m_hfile == INVALID_HANDLE_VALUE)
		throw  icj_exception (ICJ_STREAM, ERR_INVALID_HANDLE);
	if (!::WriteFile (m_hfile, buff, size * count, &wsiz, NULL))
		throw  icj_exception (ICJ_STREAM, ERR_FILE_WRITE);
	return  wsiz;
}

///////////////////////////////////////////////////////////////////////////////
//	t@C|C^
///////////////////////////////////////////////////////////////////////////////
BOOL
icj_fstream::seek (DWORD method, LONG offset)
{
	DWORD	opv;

	if (m_hfile == INVALID_HANDLE_VALUE)
		return  FALSE;
	opv = ::SetFilePointer (m_hfile, offset, NULL, method);
	return  opv == 0xffffffff ? FALSE : TRUE;
}

BOOL
icj_fstream::rewind ()
{
	return  seek (FILE_BEGIN, 0);
}

DWORD
icj_fstream::tell ()
{
	return  ::SetFilePointer (m_hfile, 0, NULL, FILE_CURRENT);
}

///////////////////////////////////////////////////////////////////////////////
//	TCY
///////////////////////////////////////////////////////////////////////////////
DWORD
icj_fstream::getSize ()
{
	return  ::GetFileSize (m_hfile, NULL);
}

///////////////////////////////////////////////////////////////////////////////
//	쐬^n
///////////////////////////////////////////////////////////////////////////////
BOOL
icj_fstream::create (	// VKt@CXg[쐬
	LPCTSTR	file_name,	// t@C
	BOOL	purge)		// ji폜j
{
	if (m_hfile != INVALID_HANDLE_VALUE || !copyname (file_name))
		return  FALSE;

	init ();
	m_hfile = ::CreateFile (file_name, GENERIC_READ | GENERIC_WRITE,
							FILE_SHARE_READ, NULL, CREATE_NEW,
							FILE_ATTRIBUTE_NORMAL, (HANDLE) NULL);
	if (INVALID_HANDLE_VALUE == m_hfile)
	{
		xfree (m_fname);
		m_fname = NULL;
		return  FALSE;
	}
	m_purge = purge;
	return  TRUE;
}

BOOL
icj_fstream::open (		// t@C̃I[v
	LPCTSTR	file_name,	// t@C
	BOOL	ronly,		// ǂݏoptO
	BOOL	purge)		// ji폜j
{
	DWORD	facc = ronly ? GENERIC_READ : GENERIC_READ | GENERIC_WRITE;

	if (m_hfile != INVALID_HANDLE_VALUE || !copyname (file_name))
		return  FALSE;

	init ();
	m_hfile = ::CreateFile (file_name, facc,
							FILE_SHARE_READ, NULL, OPEN_EXISTING,
							FILE_ATTRIBUTE_NORMAL, (HANDLE) NULL);
	if (INVALID_HANDLE_VALUE == m_hfile)
	{
		xfree (m_fname);
		m_fname = NULL;
		return  FALSE;
	}
	m_purge = purge;
	return  TRUE;
}

///////////////////////////////////////////////////////////////////////////////
//	t@CRs[
///////////////////////////////////////////////////////////////////////////////
BOOL
icj_fstream::copyname (LPCTSTR file_name)
{
	DWORD	len = lstrlen (file_name);

	m_fname = (LPTSTR) xmalloc (++ len);
	if (!m_fname)
		return  FALSE;
	lstrcpy (m_fname, file_name);
	return  TRUE;
}

///////////////////////////////////////////////////////////////////////////////
//	Oj
///////////////////////////////////////////////////////////////////////////////
BOOL
icj_fstream::attach (HANDLE hfile, BOOL close)
{
	if (m_hfile != INVALID_HANDLE_VALUE)
		return  FALSE;
	init ();
	m_hfile = hfile;
	m_fname = NULL;
	m_close = close;
	return  TRUE;
}

///////////////////////////////////////////////////////////////////////////////
//	폜
///////////////////////////////////////////////////////////////////////////////
BOOL
icj_fstream::remove ()
{
	if (m_hfile == INVALID_HANDLE_VALUE)
		return  FALSE;
	// 폜FA attach ꂽ̂͏B
	if (m_fname == NULL)
	{
		if (m_close)
			::CloseHandle (m_hfile);
		init ();
		return  FALSE;
	}
	m_purge = TRUE;
	return  close ();
}

///////////////////////////////////////////////////////////////////////////////
//	j𕪗
///////////////////////////////////////////////////////////////////////////////
HANDLE
icj_fstream::isolate ()
{
	HANDLE	hr;

	if (m_hfile == INVALID_HANDLE_VALUE)
		return  NULL;
	hr = m_hfile;
	if (m_fname)
	{
		xfree (m_fname);
		m_fname = NULL;
	}
	init ();
	return  hr;
}
